#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "gram.y"
/* $Header: /local/src/CVS/nickle/gram.y,v 1.144 2004/12/11 06:02:23 keithp Exp $ */

/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 1 shift/reduce conflict and 4 reduce/reduce:
 * 
 * 2 reduce/reduce conflicts on:
 *
 *	    *int . func 
 *	    **int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 * 2 reduce/reduce conflicts on:
 *
 *	   &int . func
 *	   &&int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers.
 *	(Of course, you can always enclose an assignment in parens.)
 *      (I can't see any obvious way to use operator precedence to
 *      get rid of this: seems like you'd need to duplicate simpleexpr
 *      with different precedence. --BCM)
 *
 */
int ignorenl;
int notCommand;
int seeComment;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static Expr *
ParseCanonFor (Expr *expr);

static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);

#line 72 "gram.y"
typedef union {
    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;
} YYSTYPE;
#line 102 "gram.c"
#define VAR 257
#define EXPR 258
#define ARRAY 259
#define STRUCT 260
#define UNION 261
#define ENUM 262
#define COMP 263
#define HASH 264
#define SEMI 265
#define MOD 266
#define OC 267
#define CC 268
#define DOLLAR 269
#define DOTDOTDOT 270
#define ENDFILE 271
#define GLOBAL 272
#define AUTO 273
#define STATIC 274
#define CONST 275
#define POLY 276
#define INTEGER 277
#define NATURAL 278
#define RATIONAL 279
#define REAL 280
#define STRING 281
#define FOREIGN 282
#define FILET 283
#define MUTEX 284
#define SEMAPHORE 285
#define CONTINUATION 286
#define THREAD 287
#define VOID 288
#define BOOL 289
#define FUNCTION 290
#define FUNC 291
#define EXCEPTION 292
#define RAISE 293
#define TYPEDEF 294
#define IMPORT 295
#define NEW 296
#define ANONINIT 297
#define NAMESPACE 298
#define PUBLIC 299
#define PROTECTED 300
#define EXTEND 301
#define WHILE 302
#define DO 303
#define FOR 304
#define SWITCH 305
#define BREAK 306
#define CONTINUE 307
#define RETURNTOK 308
#define FORK 309
#define CASE 310
#define DEFAULT 311
#define TWIXT 312
#define NAME 313
#define TYPENAME 314
#define NAMESPACENAME 315
#define COMMAND 316
#define NAMECOMMAND 317
#define TEN_NUM 318
#define OCTAL0_NUM 319
#define OCTAL_NUM 320
#define BINARY_NUM 321
#define HEX_NUM 322
#define TEN_FLOAT 323
#define OCTAL0_FLOAT 324
#define OCTAL_FLOAT 325
#define BINARY_FLOAT 326
#define HEX_FLOAT 327
#define CHAR_CONST 328
#define STRING_CONST 329
#define POLY_CONST 330
#define THREAD_CONST 331
#define COMMENT_CONST 332
#define VOIDVAL 333
#define BOOLVAL 334
#define DARROW 335
#define POUND 336
#define COMMA 337
#define ASSIGN 338
#define ASSIGNPLUS 339
#define ASSIGNMINUS 340
#define ASSIGNTIMES 341
#define ASSIGNDIVIDE 342
#define ASSIGNDIV 343
#define ASSIGNMOD 344
#define ASSIGNPOW 345
#define ASSIGNSHIFTL 346
#define ASSIGNSHIFTR 347
#define ASSIGNLXOR 348
#define ASSIGNLAND 349
#define ASSIGNLOR 350
#define QUEST 351
#define COLON 352
#define OR 353
#define AND 354
#define LOR 355
#define LXOR 356
#define LAND 357
#define EQ 358
#define NE 359
#define LT 360
#define GT 361
#define LE 362
#define GE 363
#define SHIFTL 364
#define SHIFTR 365
#define PLUS 366
#define MINUS 367
#define TIMES 368
#define DIVIDE 369
#define DIV 370
#define POW 371
#define STARSTAR 372
#define POW2 373
#define POW3 374
#define UNIONCAST 375
#define UMINUS 376
#define BANG 377
#define FACT 378
#define LNOT 379
#define INC 380
#define DEC 381
#define STAR 382
#define AMPER 383
#define THREADID 384
#define OS 385
#define CS 386
#define DOT 387
#define ARROW 388
#define STAROS 389
#define CALL 390
#define OP 391
#define CP 392
#define POINTER 393
#define COLONCOLON 394
#define IF 395
#define TRY 396
#define NONL 397
#define ELSE 398
#define CATCH 399
#define NL 400
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   95,   95,   98,   98,   98,   99,  100,   97,
  101,  102,  102,  103,  103,  104,  104,   96,   96,   96,
   96,   96,   96,   96,    3,    3,    5,    5,    4,    7,
    7,    7,    6,    6,   27,   27,    1,    1,    2,    2,
   28,   28,   59,   59,  105,  106,    8,  107,  108,   14,
   14,   17,   17,   15,   15,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,  110,   16,   16,   16,   16,   69,   69,   19,   19,
   18,   12,   12,   13,    9,    9,  111,   10,   20,   20,
  109,  109,  112,   80,   81,   81,   21,   22,   22,   23,
   23,   24,   25,   25,   26,   26,   37,   37,   33,   33,
   35,   35,   40,   40,   34,   34,   36,   43,   38,   39,
   39,   39,   41,   41,   41,   42,   42,   42,   42,   42,
   42,   42,   46,   46,   46,   46,   46,   46,   45,   45,
   45,   45,   45,   47,   47,   47,   47,   47,   47,   44,
   44,   51,   51,   51,   51,   51,   51,   51,   51,   51,
   51,   51,   51,   51,   48,   48,   49,   49,   50,   50,
   52,   52,   53,   53,   54,   54,   55,   55,   55,   55,
   56,   56,   57,   57,   58,   58,   60,   60,   61,   61,
   62,   62,   65,   63,   63,   64,   64,   66,   66,   67,
   67,   68,   68,   70,   70,   76,   76,   71,   71,   72,
   72,   74,   74,   75,   75,   11,  113,   11,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   78,   78,
   77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
   77,   77,   77,   79,   79,   79,   79,   79,   82,   82,
   82,   83,   83,   29,   29,   30,   30,   31,   32,   84,
   84,   85,   85,   86,   86,   86,   87,   88,   88,   89,
   89,   90,   90,   91,   92,   92,   93,   93,   94,   94,
   94,   94,
};
short yylen[] = {                                         2,
    2,    0,    1,    3,    1,    1,    1,    0,    0,    0,
    0,    1,    0,    1,    0,    1,    0,    4,    6,    4,
    6,    6,    1,    1,    1,    0,    3,    1,    2,    1,
    1,    1,    3,    0,    2,    1,    2,    1,    1,    3,
    3,    2,    1,    1,    0,    0,    3,    2,    2,    2,
    0,    7,    9,    1,    1,    3,    9,   10,    9,    9,
   10,    2,    2,    3,    2,    1,    4,   10,    6,    6,
    7,    0,    9,    6,    2,   11,    3,    1,    1,    3,
    4,    2,    0,    7,    1,    1,    0,    2,    1,    4,
    1,    1,    0,    2,    1,    0,    3,    2,    0,    4,
    3,    3,    2,    0,    7,    3,    1,    0,    3,    1,
    3,    1,    1,    1,    4,    2,    1,    1,    4,    3,
    4,    4,    2,    2,    0,    4,    3,    3,    2,    3,
    2,    2,    2,    4,    4,    4,    4,    0,    2,    2,
    2,    2,    2,    1,    4,    4,    4,    3,    1,    1,
    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    3,    1,    3,    1,
    3,    1,    4,    0,    4,    0,    1,    1,    1,    1,
    1,    0,    1,    1,    1,    1,    3,    2,    3,    2,
    2,    1,    3,    2,    1,    3,    2,    2,    1,    1,
    0,    1,    0,    1,    2,    1,    3,    1,    0,    3,
    1,    1,    0,    3,    2,    3,    0,    2,    3,    7,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    3,    3,    3,    3,    3,    3,
    3,    2,    2,    3,    3,    5,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    2,    6,    8,    8,    8,    3,    6,    2,
    1,    3,    3,    4,    4,    4,    3,    3,    1,    0,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    0,    5,    9,    2,    1,    3,    1,    1,    0,    3,
    1,    1,    1,    1,    2,    0,    4,    3,    1,    3,
    2,    1,    1,    4,    3,    1,    3,    3,    1,    1,
    1,    2,
};
short yydefred[] = {                                      2,
    0,   10,   24,   23,    1,    3,    0,    0,    0,    0,
    0,   66,    0,   45,    0,  177,  178,  179,  180,  152,
  153,  154,  155,  156,  164,  157,  158,  159,  160,  161,
  162,  163,    8,    0,  183,  184,  186,    8,    8,    8,
    8,    0,    0,    0,    0,    8,   43,   36,    0,    0,
    0,  259,  261,  260,  262,  263,  264,  266,  265,  267,
  268,  269,  270,  271,  272,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  281,    0,    8,    8,  258,
   55,   10,   54,   46,    9,  149,    0,   93,   45,    0,
    0,    0,    0,  144,    0,    0,    0,    0,   38,    0,
    0,    0,    0,    0,    6,    7,    5,    4,    0,    0,
    0,  304,  306,  305,  307,  308,  221,   48,  280,  289,
    0,    0,    0,   45,   45,   45,   45,   62,   63,    0,
    0,    0,    0,    0,  202,    0,    0,   45,   42,   10,
  208,    0,   10,    0,   25,    0,  142,    0,  143,    0,
    0,  140,    0,  141,    0,    0,    0,    0,    0,  273,
    0,    0,    0,    0,   45,    0,    0,    9,   75,   35,
    0,   37,    0,    0,    8,    0,    0,  205,    0,   45,
    0,   12,  129,    0,    0,  139,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  131,    8,    8,    8,    0,
    0,  132,    8,   65,    0,    0,    0,  303,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  242,  243,  229,  231,  233,    0,    0,    0,    0,    0,
    0,    0,   46,    0,    0,    8,    0,  150,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  117,
   64,    0,    0,    0,    0,   34,   30,   32,   31,    0,
    0,    0,    0,    0,    0,  283,    0,    0,  282,    0,
    0,   79,   83,   20,   56,   41,   86,   46,   85,    0,
   95,   94,    0,    0,    0,  120,    0,    0,    0,  278,
  170,    0,    0,    0,    0,    0,  188,    0,    0,    0,
  133,  142,  143,  140,  141,    0,    0,  127,    0,    0,
    0,  128,    0,  130,    0,   10,   18,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  287,
  288,    0,    0,    0,  212,    0,    0,    0,   47,   50,
   45,    0,  145,    0,  146,    0,  147,  122,    0,    0,
    0,    0,    0,    0,   14,    0,  210,    0,   27,   33,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   67,   89,   88,    0,  119,    0,    0,  194,    0,  121,
    0,    0,  339,  341,  340,  124,  118,    0,    8,   93,
    0,    0,    0,    0,    0,  191,  187,  200,    0,  190,
  148,   45,  114,    0,    0,    0,    0,    0,    0,  126,
   44,   72,    0,    0,  285,  284,    0,  215,  286,   49,
    0,    0,    0,  109,    0,    0,    0,    0,    0,    0,
    0,   21,   22,   45,  167,   45,   45,  171,    0,   46,
    0,   80,    0,   82,    0,  198,    0,  197,  342,    0,
    0,    0,    0,    0,  321,    0,  329,    0,  336,  323,
  115,    0,    0,  137,  134,  169,  135,  136,  189,    0,
    9,    0,  113,    0,    0,    9,    0,   19,    0,  214,
    0,  173,  175,   69,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  274,    0,   45,    0,  196,    0,
    0,  331,  333,    0,    0,    0,    0,    0,    0,    0,
    0,  193,   46,    0,    0,   46,   70,  111,    9,   40,
   74,    0,    0,   46,    0,   77,   46,   46,    0,    0,
    0,   46,  324,    0,   46,    0,   46,  309,    0,    0,
   90,    0,  338,  318,  319,    0,  330,    0,  320,    0,
    0,  328,  327,    0,  335,  334,  220,    0,  218,   93,
   71,    0,    0,    9,   46,    9,    9,    0,    0,   46,
    0,    0,  325,  277,  275,  310,  276,    0,   93,    0,
    0,  312,    0,    0,    9,   46,    0,   57,    9,   59,
   60,    0,    0,   97,   98,   46,   53,    0,    0,  316,
    9,   73,    9,   45,    0,   46,    0,   58,    0,  101,
    9,   46,    0,  315,   46,   68,   61,    0,    0,  102,
  103,  100,   76,   84,  314,    0,    0,  106,  313,  107,
    0,    0,   46,  105,
};
short yydgoto[] = {                                       1,
   80,  439,  143,  144,  145,  146,  280,   81,  298,  299,
  543,  400,  474,  253,  254,   83,   84,   85,  293,  403,
  558,  600,  601,  616,  636,  637,   86,   87,  645,  575,
  576,  610,  263,  178,  435,  179,  661,   88,   89,  436,
  308,   90,  418,   91,  136,  186,   93,  313,  283,  315,
   94,  284,  259,  261,   95,   96,   97,   98,   99,  187,
  319,  320,  303,  408,  420,  409,  430,  458,  459,  255,
  140,  141,  101,  364,  365,  102,  251,  119,  117,  173,
  302,  567,  413,  484,  485,  562,  414,  486,  487,  532,
  415,  488,  489,  490,    5,    6,    8,  108,  304,  169,
    7,  183,  386,  537,  118,  368,  103,  369,  104,  507,
  300,  174,  545,
};
short yysindex[] = {                                      0,
 -244,    0,    0,    0,    0,    0, 1250, -252, -169, -159,
 -149,    0,  145,    0,  145,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   88,    0,    0,    0,    0,    0,    0,
    0, -142, -126, 5101, 6253,    0,    0,    0, -213, 6253,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 6253, 6253, 6253, 6253, 6253,
 6253, 6253, 6253, 6253, -191,    0, 4973,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  110,    0,    0,  -93,
  -84, -288, -180,    0,  986,  118,  559,  -77,    0, -198,
 6664,  -32, 1382,  -44,    0,    0,    0,    0, 6407, 6407,
  -13,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    6,  -57,  116,    0,    0,    0,    0,    0,    0, -159,
 -149,   16,  559,   74,    0,   -9, 2144,    0,    0,    0,
    0, 2032,    0,   37,    0,  174,    0,  385,    0,  385,
  385,    0,  385,    0,  385,  385,  385,  385,  385,    0,
 5613,  -49,  -52,   -4,    0, 1514,  -18,    0,    0,    0,
    1,    0,  142,   83,    0,  105,   30,    0,  101,    0,
  130,    0,    0, 5741, 3845,    0, -180, -213, 6407, 6407,
 6407, 6407, 6407,  -25,  -18,    0,    0,    0,    0,  -18,
  986,    0,    0,    0, 5101,   26, 6253,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 6253, 6253, 6253, 6253, 6253, 6253, 6253, 6253, 6253, 6253,
 6253, 6253, 6253, 6253, 6253, 6253, 6253, 6253, 6253, 6253,
    0,    0,    0,    0,    0, 6253,  137,  144, 6253, 6253,
 6253, 6253,    0, 1382,  196,    0,  -13,    0,  207,  -13,
  216,  155,  228,  107, 6253,  108, 1382,  109,  111,    0,
    0,  115,  242, 6253,  242,    0,    0,    0,    0,  120,
 6253,  -91,  -62,  131, 6446,    0,  203,    0,    0,  129,
 1382,    0,    0,    0,    0,    0,    0,    0,    0,  251,
    0,    0,  132, 6407,  134,    0, 5869,  185,  140,    0,
    0,  -20,  146,  197,  -60,  147,    0,  223,  150, -141,
    0,    0,    0,    0,    0,  154,    1,    0,  224, 6366,
   88,    0,  -18,    0,  127,    0,    0,  230, 6500, 2253,
 2362, 2471, 2580, 2689,  698,  698,  835,  835,  835,  835,
 1093, 1093,  293,  293,  230,  230,  230,  230,  153,    0,
    0,  158, 1904,  156,    0, 6664, 6664,  270,    0,    0,
    0,  282,    0,  284,    0,  -13,    0,    0,  163, 5101,
  248, 5101, 5101, 5101,    0,  157,    0,  161,    0,    0,
  164,  190,  171,  173, 6253,  175,  301, 5101,  306,  176,
    0,    0,    0,  240,    0,  266,    0,    0,  -70,    0,
 5229, 6664,    0,    0,    0,    0,    0,   16,    0,    0,
 -180, -180,  310, -180, -180,    0,    0,    0, 6407,    0,
    0,    0,    0,    0,  317,  246,   48,  249,  322,    0,
    0,    0,  188, 6253,    0,    0, 6253,    0,    0,    0,
  199, 6407, 6407,    0,  331,  205,  215,  333,  217,  220,
  348,    0,    0,    0,    0,    0,    0,    0, 6253,    0,
  222,    0,   88,    0, 6253,    0, 6407,    0,    0,  288,
 5869, -191, 6555,  283,    0,  290,    0,  291,    0,    0,
    0,  239,    0,    0,    0,    0,    0,    0,    0,  243,
    0,   48,    0,  368,   88,    0,  369,    0, 2144,    0,
 5101,    0,    0,    0, 1382, 5101, 5101, 1382,  251, 5101,
  370,  372,  373,  385,    0, 1382,    0, 1647,    0, 5869,
 6664,    0,    0,  328, 5869, 5869,  365, 5997,  376,  332,
  378,    0,    0,  309,  251,    0,    0,    0,    0,    0,
    0, 1382,  257,    0,  258,    0,    0,    0,   39,  259,
 5357,    0,    0, 6125,    0, 5485,    0,    0,  256,  140,
    0, 6664,    0,    0,    0,  327,    0, 6664,    0,  403,
 6555,    0,    0,  288,    0,    0,    0, 6253,    0,    0,
    0,  407,  251,    0,    0,    0,    0, 5101,  324,    0,
   39, 1382,    0,    0,    0,    0,    0, 1382,    0,  299,
  328,    0, 6664,  412,    0,    0,   60,    0,    0,    0,
    0,  334, 1382,    0,    0,    0,    0,  251, -178,    0,
    0,    0,    0,    0,  339,    0,   60,    0, 1382,    0,
    0,    0, 5869,    0,    0,    0,    0,  366, 1382,    0,
    0,    0,    0,    0,    0,  429,  392,    0,    0,    0,
  405, 1382,    0,    0,
};
short yyrindex[] = {                                      0,
 1118,    0,    0,    0,    0,    0,  143,    0,    0,  419,
  453,    0,    0,    0, 1584,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -174,  472,    0,    0,    0, 1712, -230,
 -122,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  472,  472,  472,  472,  472,
  472,  472,  472,  472,    0,    0,  472,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   25,  489,    0,  -10,  466,  138,    0,    0,  367,
 -242, -255,   19,    0,    0,    0,    0,    0,  -55,    8,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  455,    0,    0,  478, 4793,    0,    0,    0,
    0, -237,    0, -232,    0,    0,    0, 2096,    0, 2206,
 2316,    0, 2426,    0, 2536, 2646, 2756, 2866, 2976,    0,
  472,    0,   46,    0,    0,  143,  864,    0,    0,    0,
 1712,    0, -135, -116,    0,    0, -119,    0, -231,    0,
    0,    0,    0, -259,    0,    0,  489,    0,    0,    0,
    0,    0,    0,    0,  -10,    0,    0,    0,    0,  -10,
  -10,    0,    0,    0,  472,    0,  472,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  472,  472,  472,  472,  472,  472,  472,  472,  472,  472,
  472,  472,  472,  472,  472,  472,  472,  472,  472,  472,
    0,    0,    0,    0,    0,  472,    0,    0,  472, -248,
  472,  472,    0,  560,    0,    0,    0,    0,    0,    0,
    0,   36,    0,    0, -235,    0,  143,    0,    0,    0,
    0,    0,  375,  472,  375,    0,    0,    0,    0, -236,
 -161,  478,    0,    0,  391,    0,    0,  238,    0,    0,
   19,    0,    0,    0,    0,    0,    0,    0,    0,  440,
    0,    0,    0, -220,    0,    0,  472,   17,    0,    0,
    0,  478,    0,  396,    0,    0,    0, -190,    0,  393,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -10,    0,    0,    0,    0,  969,    0, 4773,
 4683, 4662, 4570, 4547, 4424, 4450, 4028, 4127, 4226, 4325,
 3826, 3927, 3620, 3723, 3196, 3302, 3408, 3514,    0,    0,
    0,    0,  393,    0,    0,  -64, -212,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  472,
    0, -250,  472, -174,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  472, 6610,    0,  472,    0,  427,
    0,    0,    0,    0,    0,    0, -221,    0,  393,    0,
  472,   68,    0,    0,    0,    0,    0,    0,    0,    0,
  489,  489,    0,  489,  489,    0,    0,    0,    0,    0,
    0,    0,    0,   -6,    0,  518,    0,  521,    0,    0,
    0,    0,    0,  472,    0,    0,  472,    0,    0,    0,
    0,  -55,    8,    0,    0,    0,    0,  395,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  472,    0,
    0,    0,    0,    0,  472,    0,  475,    0,    0, 1774,
  472,  476, -228,  113,    0,  522,    0,  522,    0,    0,
    0,    0,  -92,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 4879,    0,
  472,    0,    0,    0,  143,  472, -250,  143,    0, -227,
 1840,    0, 1968, 3086,    0,  143,    0,    0,    0,  472,
 -185,    0,    0,    0,  472,   50,  523,   15,    0,  524,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   19,    0,    0,    0,    0,    0,    0,  525,    0,
  472,    0,    0,  472,    0,  472,    0,    0,  723,    0,
    0, -184,    0,    0,    0,  410,    0, -228,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  472,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  472,    0,    0,
  525,  143,    0,    0,    0,    0,    0,  143,    0,    0,
    0,    0,   62,    0,    0,    0,  532,    0,    0,    0,
    0,    0,  560,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  532,    0,  560,    0,
    0,    0,  472,    0,    0,    0,    0,    0,  560,    0,
    0,    0,    0,    0,    0,    0,  449,    0,    0,    0,
    0,  560,    0,    0,
};
short yygindex[] = {                                      0,
  -29,  300,    0,    0,  533,    0,    0,  -76,    0,    0,
    0,    0,    0, -243,   -3,  644,    0,    0,    0,    0,
    0,  210,    0,    0,  178,    0,    0,  467,    0,  202,
    0,    0, -153,  398, -380,    0,    0,    0,    0,    0,
    0,  -38,    0,  -88,   -7, -156,    0,    0,  633,    0,
    0, -181,  377,  371,  152,    0,  -26,    0,  -85,  330,
  408,    0,  430,  379,  280,    0, -327,  -37,  336,   10,
  592,  585,    5,    0,  413,    0,    0,    0,  846, -400,
    0,    0,  -51,    0, -512,    0,  341,    0,  325,  337,
    0,    0,  326, -282,    0,    0,  -74,    0,   95, -138,
    0,  -81,  590,  -33,  -80,   27, -406, -337,    0,    0,
    0,    0,    0,
};
#define YYTABLESIZE 7055
short yytable[] = {                                      92,
  162,  172,  316,   82,  122,  132,  134,  167,  175,  204,
  370,    2,  105,  196,  203,  202,  100,  133,  106,  493,
  257,  260,  206,  579,  416,  206,    3,  211,   29,  295,
  321,  151,   28,  125,  209,  448,   92,  172,  132,  322,
  151,  322,  151,  266,  267,  268,  269,  399,  199,  137,
  133,  202,  207,  135,  142,  151,  504,  272,  147,  149,
  151,  152,  154,  151,  359,  273,  204,  362,  275,  163,
  148,  150,  151,  153,  155,  156,  157,  158,  159,  192,
  204,  478,  332,  337,  290,  294,  164,  195,   14,  200,
  203,  150,  151,  206,  206,   92,  204,  109,  181,  309,
   29,  258,  258,  372,  125,  125,  374,  110,  322,  206,
  168,  182,  559,  328,  470,  199,  151,  111,  332,  334,
  125,  548,  128,  207,  207,  200,  166,  121,  428,  151,
  655,   87,  124,  125,  126,  127,  204,  205,  129,  207,
  138,  203,   26,  213,  204,  117,  192,  107,   96,  206,
   96,  332,  337,  282,  211,    4,  209,  206,   92,  643,
  125,  404,  211,   29,  203,  285,  132,   28,  125,  209,
  199,  195,  165,  166,  217,  168,  312,  318,  133,  207,
  139,  322,  323,  324,  325,  326,  617,  207,  285,  614,
   34,   34,   34,  333,  160,  429,  176,   92,  533,  428,
  219,  192,   87,  219,  184,  219,  180,  397,  628,  580,
  185,  338,  174,  468,  336,  406,  117,  117,  117,  177,
  203,   96,  454,  402,  168,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,    9,   92,  573,  201,  442,
  285,  440,  533,  285,  363,  366,  367,  151,  113,   92,
  256,  443,  624,  381,  494,  495,  477,  497,  498,  142,
  219,  219,  219,  152,  392,  176,  423,   26,  142,   13,
  117,  116,   16,   92,  201,  153,   51,  219,  170,  327,
  451,  329,  330,  331,  391,  181,  407,  335,  650,  262,
  110,  438,   13,  110,  252,  151,   36,   36,  592,  151,
  182,  412,  182,  182,   13,  150,  182,   16,  264,   16,
  151,  219,  437,  393,  401,  424,  216,  219,  270,  216,
  113,  216,  123,  265,  287,  219,  150,   13,  271,  288,
  151,  132,  286,  132,  132,  132,  461,  182,  598,  599,
  371,  500,  116,  133,  544,  133,  133,  133,   13,  132,
  433,  503,  547,  257,  260,  421,  181,  551,  116,  634,
  635,  133,   92,  276,   92,   92,   92,  181,   36,  640,
   17,  182,   17,  521,   36,  522,  523,  289,  406,  456,
   92,  135,  460,  135,  296,  652,  216,  216,  216,  285,
   47,  534,   49,  123,  123,  658,  297,  471,  116,  197,
  591,  198,  199,  216,  301,  483,  116,  305,  663,  123,
  306,  318,   47,  170,  171,  337,   81,   13,   47,  181,
  171,  181,  181,  151,  182,  181,  182,  182,  307,   47,
  182,  441,  310,  527,  258,  258,  570,  216,  509,  360,
   13,  363,  539,  216,  541,  618,  361,  620,  621,  123,
  204,  216,  112,  113,  114,  115,  116,  123,  589,  407,
  565,  568,  132,  524,  373,  438,  632,  132,  132,  528,
  638,  132,  560,  375,  133,  531,  277,  278,  279,  133,
  133,  376,  646,  133,  647,  377,  525,  378,  380,  382,
  123,  383,  653,   92,   45,  384,  385,   92,   92,   92,
   92,  554,   92,  390,  557,  396,  394,   14,   92,  398,
  553,  417,  569,  405,  410,  555,  135,  148,  148,  135,
  419,  422,  425,  392,  572,  426,  432,  450,  445,  531,
  578,  427,  581,  446,   92,  431,  452,  449,  453,  457,
  148,  642,  644,  648,  455,  464,  462,  465,  207,  132,
  463,  194,  466,  194,  467,  581,  469,  411,  578,  587,
  578,  133,  590,  472,  473,  194,  194,  475,  476,  496,
  594,  501,  502,  596,  597,  505,  506,  508,  604,  511,
   92,  605,  613,  607,   92,  514,  515,  517,  626,  194,
   92,  240,  241,  242,  627,  516,  243,  622,  518,  244,
  245,  519,  520,  526,  246,   92,  247,  248,  249,  536,
  250,  619,  148,  148,  148,  530,  538,  540,  148,  148,
  542,   92,  549,  185,  428,  552,  561,  148,  564,  566,
  574,   92,  633,  583,  584,  586,  588,  578,  593,  595,
  602,  194,  641,  608,   92,  194,  194,  194,  194,  194,
  237,  238,  239,  611,  240,  241,  242,  194,  654,  243,
  612,  656,  244,  245,  615,  623,  631,  246,  657,  247,
  248,  249,   81,  250,  629,  639,   81,   81,   81,  664,
  649,   81,   81,   81,   81,   81,  659,   81,   81,   81,
   81,   81,   81,   81,  660,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   52,   91,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,  662,   92,  138,   81,
   81,  243,  151,  185,  244,  245,   10,   13,  150,  246,
  194,  247,  248,  249,   15,  250,  172,    9,  138,  138,
   81,  165,  112,   81,  201,   39,   78,  151,   45,   17,
  201,   16,   99,   81,   81,  317,  194,  123,   81,  104,
  108,  138,  138,   81,  550,   81,   81,   81,  389,  292,
  625,   81,  630,   81,  651,  491,  314,   81,    9,  130,
  131,   81,   81,  513,   81,  138,   81,   51,  512,  546,
   16,   17,   18,   19,   20,   21,  499,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,  492,  609,
  151,  182,  556,  182,  182,  529,  379,  182,  387,  510,
  120,  563,  582,   13,  388,  585,    0,    0,    0,   51,
   51,  577,   48,  188,  138,  138,    0,    0,    0,    0,
  138,    0,    0,    0,    0,    0,    0,    0,  138,    0,
    0,    0,    0,    0,    0,  194,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  189,    0,    0,  190,    0,    0,  194,  194,
    0,    0,    0,    0,    0,    0,  191,    0,    0,    0,
  192,    0,    0,    0,    0,    0,    0,    0,    0,  123,
    0,    0,    0,  194,    0,    0,    0,    0,    0,  193,
    0,    0,    0,    0,    0,    0,    0,    0,  182,    0,
    0,    0,    0,  207,    0,    0,    0,    0,    0,    0,
    0,  123,    0,    0,    0,    0,    0,    0,   52,    0,
    0,    0,   52,   52,   52,    0,    0,   52,   52,   52,
   52,   52,    0,   52,   52,   52,   52,   52,   52,   52,
    0,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,    0,    0,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,    0,    0,    0,   52,   52,  229,  230,  231,
  232,  233,  234,  235,  236,  237,  238,  239,    0,  240,
  241,  242,    0,    0,  243,    0,   52,  244,  245,   52,
    0,    0,  246,    0,  247,  248,  249,    0,  250,   52,
   52,    0,    0,    0,   52,    0,    0,    0,    0,   52,
  207,   52,   52,   52,    0,    0,    0,   52,    0,   52,
    0,    0,    0,   52,    0,    0,    0,   52,   52,   13,
    0,   52,   52,   13,   13,   13,    0,    0,   13,   13,
   13,    0,   13,    0,   13,   13,   13,   13,   13,   13,
   13,    0,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,    0,
    0,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,    0,    0,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,    0,    0,    0,   13,   13,  233,  234,
  235,  236,  237,  238,  239,    0,  240,  241,  242,    0,
    0,  243,    0,    0,  244,  245,    0,   13,    0,  246,
   13,  247,  248,  249,    0,  250,    0,    0,    0,    0,
   13,   13,    0,  240,  240,   13,  240,    0,  240,    0,
   13,    0,   13,   13,   13,    9,  130,  131,   13,    0,
   13,    0,    0,    0,   13,    0,    0,    0,   13,   13,
    0,   20,   21,    0,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   48,
  188,    0,    0,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  189,
    0,    0,  190,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  191,  240,    0,    0,  192,  207,    0,
  240,    0,    0,    0,    0,    0,    0,    0,  240,    0,
    0,    0,    0,    0,    0,    0,  193,   11,   11,   11,
    0,    0,   11,   11,   11,  182,   11,    0,    0,   11,
   11,   11,   11,   11,   11,    0,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,    0,    0,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,    0,    0,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,    0,    0,    0,
   11,   11,    0,    0,    0,    0,    0,    0,  235,  236,
  237,  238,  239,    0,  240,  241,  242,    0,    0,  243,
    0,   11,  244,  245,   11,    0,    0,  246,    0,  247,
  248,  249,    0,  250,   11,   11,    0,    0,    0,   11,
    0,    0,    0,    0,   11,    0,   11,   11,   11,    0,
    0,    0,   11,    0,   11,    0,    0,    0,   11,    9,
   10,   11,   11,   11,   12,   13,   14,    0,   15,    0,
    0,   16,   17,   18,   19,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
    0,    0,   34,    0,    0,    0,    0,    0,   35,   36,
   37,   38,   39,   40,   41,   42,   43,   44,   45,    0,
    0,   46,   47,   48,   49,   50,   51,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   66,    0,    0,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   68,   69,    0,    0,
    0,   70,    0,    0,    0,    0,   71,    0,   72,   73,
   74,    0,    0,    0,   75,    0,   76,    0,    0,    0,
   77,    9,   10,   11,   78,   79,   12,   13,   14,    0,
   15,    0,    0,   16,   17,   18,   19,   20,   21,    0,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,   33,    0,    0,   34,    0,    0,    0,    0,    0,
   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
   45,    0,    0,   46,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,    0,   64,   65,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    0,
    0,    0,   77,    9,   10,   11,   78,   79,   12,   13,
  291,    0,   15,    0,    0,   16,   17,   18,   19,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,   33,    0,    0,   34,    0,    0,    0,
    0,    0,   35,   36,   37,   38,   39,   40,   41,   42,
   43,   44,   45,    0,    0,   46,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,    0,   64,   65,  290,  290,
    0,  290,    0,  290,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   66,    0,    0,
   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   68,   69,    0,    0,    0,   70,    0,    0,    0,    0,
   71,    0,   72,   73,   74,    0,    0,    0,   75,    0,
   76,    0,    0,    0,   77,    0,    0,    0,   78,   79,
    0,  571,  207,    0,    0,    0,    0,    0,  290,  290,
  290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
  290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
  290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
  290,  290,  290,  290,    0,  290,  290,  290,    0,    0,
  290,    0,    0,  290,  290,    0,    0,    0,  290,  290,
  290,  290,  290,    0,  290,  290,   44,   44,    0,   44,
    0,   44,    0,  290,  208,  209,  210,  211,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,    0,  222,
  223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
  233,  234,  235,  236,  237,  238,  239,    0,  240,  241,
  242,    0,    0,  243,    0,    0,  244,  245,    0,    0,
    0,  246,    0,  247,  248,  249,    0,  250,    0,   43,
    0,   43,    0,   43,    0,    0,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,    0,   44,   44,   44,    0,    0,   44,    0,
    0,   44,   44,    0,    0,    0,   44,   44,   44,   44,
   44,    0,   44,   44,  326,  326,    0,  326,   43,  326,
   43,   44,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,    0,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,    0,   43,   43,   43,    0,    0,
   43,    0,    0,   43,   43,    0,    0,    0,   43,    0,
   43,   43,   43,    0,   43,    0,    0,    0,    0,  207,
    0,    0,    0,  428,  326,  326,  326,  326,  326,  326,
  326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
  326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
  326,  326,  326,  326,  326,  326,  326,  326,  326,  326,
    0,  326,  326,  326,    0,    0,  326,    0,    0,  326,
  326,    0,    0,    0,  326,  326,  326,  326,  326,    0,
  326,  326,  311,  311,    0,  311,    0,  311,    0,  326,
  447,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,    0,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,    0,  240,  241,  242,    0,    0,
  243,    0,    0,  244,  245,    0,    0,    0,  246,    0,
  247,  248,  249,    0,  250,    0,    0,  207,    0,    0,
    0,    0,  311,  311,  311,  311,  311,  311,  311,  311,
  311,  311,  311,  311,  311,  311,  311,  311,  311,  311,
  311,  311,  311,  311,  311,  311,  311,  311,  311,  311,
  311,  311,  311,  311,  311,  311,  311,  311,    0,  311,
  311,  311,    0,    0,  311,    0,    0,  311,  311,    0,
    0,    0,  311,  311,  311,  311,  311,    0,  311,  311,
  225,  225,    0,  225,    0,  225,    0,  311,  274,  208,
  209,  210,  211,  212,  213,  214,  215,  216,  217,  218,
  219,  220,  221,    0,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
  238,  239,    0,  240,  241,  242,    0,    0,  243,  207,
    0,  244,  245,    0,    0,    0,  246,    0,  247,  248,
  249,    0,  250,    0,    0,    0,    0,    0,    0,    0,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,    0,  225,  225,  225,
  224,  224,    0,  224,    0,  224,    0,    0,    0,    0,
    0,  225,    0,    0,    0,    0,    0,  225,    0,    0,
    0,    0,    0,    0,  221,  225,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,    0,  240,  241,  242,  207,    0,
  243,    0,    0,  244,  245,    0,    0,    0,  246,    0,
  247,  248,  249,    0,  250,    0,    0,    0,    0,    0,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,    0,  224,  224,  224,
  226,  226,    0,  226,    0,  226,    0,    0,    0,    0,
    0,  224,    0,    0,    0,    0,    0,  224,    0,    0,
    0,    0,    0,    0,    0,  224,  223,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,  239,    0,  240,  241,  242,  207,    0,  243,
    0,    0,  244,  245,    0,    0,    0,  246,    0,  247,
  248,  249,    0,  250,    0,    0,    0,    0,    0,    0,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,    0,  226,  226,  226,
  222,  222,    0,  222,    0,  222,    0,    0,    0,    0,
    0,  226,    0,    0,    0,    0,    0,  226,    0,    0,
    0,    0,    0,    0,    0,  226,  224,  225,  226,  227,
  228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
  238,  239,    0,  240,  241,  242,  207,    0,  243,    0,
    0,  244,  245,    0,    0,    0,  246,    0,  247,  248,
  249,    0,  250,    0,    0,    0,    0,    0,    0,    0,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,    0,  222,  222,  222,
  223,  223,    0,  223,    0,  223,    0,    0,    0,    0,
    0,  222,    0,    0,    0,    0,    0,  222,    0,    0,
    0,    0,    0,    0,    0,  222,  225,  226,  227,  228,
  229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
  239,    0,  240,  241,  242,  207,    0,  243,    0,    0,
  244,  245,    0,    0,    0,  246,    0,  247,  248,  249,
    0,  250,    0,    0,    0,    0,    0,    0,    0,    0,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,    0,  223,  223,  223,
  228,  228,    0,  228,    0,  228,    0,    0,    0,    0,
    0,  223,    0,    0,    0,    0,    0,  223,    0,    0,
    0,    0,    0,    0,    0,  223,  226,  227,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
    0,  240,  241,  242,  207,    0,  243,    0,    0,  244,
  245,    0,    0,    0,  246,    0,  247,  248,  249,    0,
  250,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,    0,  228,  228,  228,
  227,  227,    0,  227,    0,  227,    0,    0,    0,    0,
    0,  228,    0,    0,    0,    0,    0,  228,    0,    0,
    0,    0,    0,    0,    0,  228,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,  237,  238,  239,    0,
  240,  241,  242,    0,    0,  243,    0,    0,  244,  245,
    0,    0,    0,  246,    0,  247,  248,  249,    0,  250,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,    0,  227,  227,  227,
  230,  230,    0,  230,    0,  230,    0,    0,    0,    0,
    0,  227,    0,    0,    0,    0,    0,  227,    0,    0,
    0,    0,    0,    0,    0,  227,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,    0,  230,  230,  230,
  232,  232,    0,  232,    0,  232,    0,    0,    0,    0,
    0,  230,    0,    0,    0,    0,    0,  230,    0,    0,
    0,    0,    0,    0,    0,  230,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,  232,    0,  232,  232,  232,
  279,  279,    0,  279,    0,  279,    0,    0,    0,    0,
    0,  232,    0,    0,    0,    0,    0,  232,    0,    0,
    0,    0,    0,    0,    0,  232,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  279,  279,  279,  279,  279,  279,  279,  279,  279,  279,
  279,  279,  279,  279,  279,  279,  279,  279,  279,  279,
  279,  279,  279,  279,  279,  279,  279,  279,  279,  279,
  279,  279,  279,  279,  279,  279,    0,  279,  279,  279,
  237,  237,    0,  237,    0,  237,    0,    0,    0,    0,
    0,  279,    0,    0,    0,    0,    0,  279,    0,    0,
    0,    0,    0,    0,    0,  279,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  238,  238,    0,  238,
    0,  238,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  237,    0,    0,    0,    0,    0,  237,    0,    0,
    0,    0,    0,    0,    0,  237,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  239,  239,    0,  239,    0,  239,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  238,    0,    0,
    0,    0,    0,  238,    0,    0,    0,    0,    0,    0,
    0,  238,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  241,  241,
    0,  241,    0,  241,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  239,    0,    0,    0,    0,    0,  239,
    0,    0,    0,    0,    0,    0,    0,  239,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  241,  241,
  241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
  241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
  241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
  241,  241,  241,  241,  235,    0,    0,  235,    0,  235,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  241,
    0,    0,    0,    0,    0,  241,    0,    0,    0,    0,
    0,    0,    0,  241,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  236,    0,    0,
  236,    0,  236,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  235,    0,    0,    0,    0,
    0,  235,    0,    0,    0,    0,    0,    0,    0,  235,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  244,    0,    0,  244,    0,  244,    0,    0,    0,    0,
    0,    0,    0,    0,    9,  130,  131,    0,  236,    0,
    0,    0,    0,    0,  236,    0,    0,    0,    0,    0,
   20,   21,  236,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   48,  188,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  245,    0,    0,  245,    0,  245,    0,  189,    0,
    0,  190,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  244,  191,    0,    0,    0,  192,  244,    0,    0,
    0,    0,    0,    0,    0,  244,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  193,  317,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  254,    0,    0,  254,    0,  254,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  245,    0,    0,    0,    0,    0,  245,    0,
    0,    0,    0,    0,    0,    0,  245,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  255,    0,    0,  255,    0,  255,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  254,    0,    0,    0,    0,    0,  254,
    0,    0,    0,    0,    0,    0,    0,  254,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  256,    0,    0,  256,    0,  256,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  255,    0,    0,    0,    0,    0,  255,    0,
    0,    0,    0,    0,    0,    0,  255,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  257,
    0,    0,  257,    0,  257,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  256,    0,    0,    0,    0,    0,  256,    0,    0,
    0,    0,    0,    0,    0,  256,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  257,
  257,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  257,  257,  252,    0,
    0,  252,    0,  252,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  257,    0,    0,    0,  253,    0,  257,  253,    0,  253,
    0,    0,    0,    0,  257,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,    0,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  252,
    0,  248,    0,    0,  248,  252,  248,    0,    0,    0,
    0,    0,    0,  252,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  247,  253,    0,  247,    0,  247,
    0,  253,    0,    0,    0,    0,    0,    0,    0,  253,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  249,    0,    0,  249,
    0,  249,  248,    0,    0,    0,    0,    0,  248,    0,
    0,    0,    0,    0,    0,    0,  248,  250,    0,    0,
  250,    0,  250,    0,    0,  247,    0,    0,    0,    0,
    0,  247,    0,    0,    0,    0,    0,    0,    0,  247,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  251,    0,    0,
  251,    0,  251,    0,    0,    0,    0,  249,    0,    0,
    0,    0,    0,  249,    0,    0,    0,  234,    0,    0,
  234,  249,  234,    0,    0,    0,    0,    0,  250,    0,
    0,    0,    0,    0,  250,    0,    0,    0,    0,    0,
    0,    0,  250,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,    0,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  246,  234,    0,  246,    0,  246,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  251,    0,
    0,    0,    0,    0,  251,    0,    0,    0,    0,    0,
    0,    0,  251,    0,    0,    0,    0,    0,  234,    0,
    0,    0,    0,    0,  234,    0,    0,    0,    0,    0,
    0,    0,  234,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  246,  246,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  246,    0,
  246,    0,    9,  130,  131,    0,    0,    0,   13,   14,
    0,   15,    0,    0,   16,   17,   18,   19,   20,   21,
    0,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,    0,    0,  246,    0,    0,    0,    0,    0,
  246,   35,   36,    0,    0,    0,    0,    0,  246,    0,
    0,   45,    0,    0,    0,   47,   48,   49,    0,    0,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,    0,   64,   65,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   66,    0,    0,   67,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
   69,    0,    0,    0,   70,    0,    0,    0,    0,   71,
    0,   72,   73,   74,    0,    0,    0,  161,    0,   76,
    9,  130,  131,   77,    0,    0,   13,    0,    0,   15,
    0,    0,   16,   17,   18,   19,   20,   21,    0,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   35,
   36,    0,    0,    0,    0,    0,    0,    0,    0,   45,
    0,    0,    0,   47,   48,   49,    0,    0,   52,   53,
   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
    0,    0,    0,   64,   65,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   66,    0,    0,   67,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,   69,    0,
    0,    0,   70,    0,    0,    0,    0,   71,    0,   72,
   73,   74,    0,    0,    0,   75,    0,   76,    9,  130,
  131,   77,    0,    0,   13,  411,  479,   15,    0,    0,
    0,    0,    0,    0,   20,   21,    0,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,    0,    0,
    0,  480,   48,   49,    0,    0,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,    0,    0,
    0,   64,   65,  481,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   66,    0,    0,   67,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   68,   69,    0,    0,    0,
   70,    0,    0,    0,    0,   71,    0,   72,   73,   74,
    0,    0,    0,  482,    0,   76,    9,  130,  131,   77,
    0,    0,   13,    0,  603,   15,    0,    0,    0,    0,
    0,    0,   20,   21,    0,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   45,    0,    0,    0,   47,
   48,   49,    0,    0,   52,   53,   54,   55,   56,   57,
   58,   59,   60,   61,   62,   63,    0,    0,    0,   64,
   65,  481,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,   67,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   68,   69,    0,    0,    0,   70,    0,
    0,    0,    0,   71,    0,   72,   73,   74,    0,    0,
    0,   75,    0,   76,    9,  130,  131,   77,    0,    0,
   13,  411,  606,   15,    0,    0,    0,    0,    0,    0,
   20,   21,    0,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   45,    0,    0,    0,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,    0,   64,   65,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   66,    0,
    0,   67,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,   69,    0,    0,    0,   70,    0,    0,    0,
    0,   71,    0,   72,   73,   74,    0,    0,    0,  482,
    0,   76,    9,  130,  131,   77,    0,    0,   13,    0,
    0,   15,    0,    0,    0,    0,    0,    0,   20,   21,
    0,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   45,    0,    0,    0,   47,   48,   49,    0,    0,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,    0,   64,   65,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   66,    0,    0,   67,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
  281,    0,    0,    0,   70,    0,    0,    0,    0,   71,
    0,   72,   73,   74,    0,    0,    0,   75,  160,   76,
    9,  130,  131,   77,    0,    0,   13,    0,    0,   15,
  311,    0,    0,    0,    0,    0,   20,   21,    0,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   45,
    0,    0,    0,   47,   48,   49,    0,    0,   52,   53,
   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
    0,    0,    0,   64,   65,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   66,    0,    0,   67,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,  281,    0,
    0,    0,   70,    0,    0,    0,    0,   71,    0,   72,
   73,   74,    0,    0,    0,   75,    0,   76,    9,  130,
  131,   77,    0,    0,   13,  411,    0,   15,    0,    0,
    0,    0,    0,    0,   20,   21,    0,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,    0,    0,
    0,   47,   48,   49,    0,    0,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,    0,    0,
    0,   64,   65,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   66,    0,    0,   67,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   68,   69,    0,    0,    0,
   70,    0,    0,    0,    0,   71,    0,   72,   73,   74,
    0,    0,    0,   75,    0,   76,    9,  130,  131,   77,
    0,    0,   13,    0,    0,   15,    0,    0,    0,    0,
    0,    0,   20,   21,    0,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   45,    0,    0,    0,   47,
   48,   49,    0,    0,   52,   53,   54,   55,   56,   57,
   58,   59,   60,   61,   62,   63,    0,    0,    0,   64,
   65,  481,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,   67,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   68,   69,    0,    0,    0,   70,    0,
    0,    0,    0,   71,    0,   72,   73,   74,    0,    0,
    0,   75,    0,   76,    9,  130,  131,   77,    0,    0,
   13,  411,    0,   15,    0,    0,    0,    0,    0,    0,
   20,   21,    0,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   45,    0,    0,    0,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,    0,   64,   65,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   66,    0,
    0,   67,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,   69,    0,    0,    0,   70,    0,    0,    0,
    0,   71,    0,   72,   73,   74,    0,    0,    0,  482,
    0,   76,    9,  130,  131,   77,    0,    0,   13,    0,
    0,   15,    0,    0,    0,    0,    0,    0,   20,   21,
    0,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   45,    0,    0,    0,   47,   48,   49,    0,    0,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,    0,   64,   65,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   66,    0,    0,   67,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
   69,    0,    0,    0,   70,    9,  130,  131,    0,   71,
    0,   72,   73,   74,    0,    0,    0,   75,    0,   76,
    0,   20,   21,   77,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    9,  130,  131,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  433,  434,
  188,    0,   20,   21,    0,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  207,    0,    0,    0,    0,    0,    0,    0,  189,
   48,  188,  190,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  191,    0,    0,    0,  192,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  193,    0,    0,    0,
  189,    0,    0,  190,    0,  207,    0,    0,    0,    0,
    0,    0,    0,    0,  191,    0,    0,    0,  192,    0,
    0,    0,  395,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  221,  193,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  237,  238,  239,    0,  240,  241,  242,
  207,    0,  243,    0,    0,  244,  245,    0,    0,    0,
  246,    0,  247,  248,  249,    0,  250,  208,  209,  210,
  211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  444,  222,  223,  224,  225,  226,  227,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
    0,  240,  241,  242,    0,  278,  243,    0,    0,  244,
  245,    0,    0,    0,  246,    0,  247,  248,  249,  535,
  250,    0,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,    0,  222,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
  235,  236,  237,  238,  239,    0,  240,  241,  242,  207,
    0,  243,    0,    0,  244,  245,    0,    0,    0,  246,
    0,  247,  248,  249,    0,  250,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,    0,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
    0,  278,  278,  278,    0,    0,  278,    0,    0,  278,
  278,    0,    0,    0,  278,    0,  278,  278,  278,    0,
  278,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,    0,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,    0,  240,  241,  242,    0,    0,
  243,    0,    0,  244,  245,    0,    0,    0,  246,    0,
  247,  248,  249,    0,  250,
};
short yycheck[] = {                                       7,
   77,   87,  184,    7,   34,   44,   44,   82,   89,  265,
  254,  256,  265,   95,  265,   97,    7,   44,  271,  420,
  109,  110,  265,  536,  307,  100,  271,  265,  265,  168,
  187,  291,  265,  265,  265,  363,   44,  123,   77,  268,
  291,  270,  291,  124,  125,  126,  127,  291,  270,   45,
   77,  133,  265,   44,   50,  291,  437,  138,   66,   67,
  291,   69,   70,  291,  246,  140,  265,  249,  143,   77,
   66,   67,   68,   69,   70,   71,   72,   73,   74,  270,
  336,  409,  268,  268,  165,  167,   77,   95,  267,   97,
  265,  313,  313,  336,  337,  103,  352,  267,  387,  180,
  337,  109,  110,  257,  336,  337,  260,  267,  337,  352,
   84,  400,  519,  195,  397,  337,  291,  267,  200,  201,
  352,  502,  265,  336,  337,  133,  386,   33,  270,  291,
  643,  267,   38,   39,   40,   41,  392,  336,  265,  352,
   46,  392,  265,  392,  400,  265,  337,  400,  265,  392,
  267,  337,  337,  161,  392,  400,  392,  400,  166,  338,
  392,  300,  400,  400,  392,  161,  205,  400,  400,  400,
  392,  392,   78,   79,  267,  337,  184,  185,  205,  392,
  394,  189,  190,  191,  192,  193,  593,  400,  184,  590,
  313,  314,  315,  201,  386,  337,  290,  205,  481,  270,
  265,  392,  338,  268,  385,  270,  291,  288,  609,  537,
  391,  207,  268,  395,  205,  304,  336,  337,  338,  313,
  298,  338,  376,  300,  386,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,  240,  338,  254,  530,   97,  335,
  246,  333,  535,  249,  250,  251,  252,  313,  265,  267,
  305,  336,  600,  267,  421,  422,  337,  424,  425,  265,
  335,  336,  337,  281,  337,  268,  337,  400,  274,  290,
  400,  265,  268,  291,  133,  281,  268,  352,  314,  315,
  371,  197,  198,  199,  386,  387,  304,  203,  636,  313,
  265,  331,  313,  268,  337,  291,  313,  314,  552,  291,
  292,  307,  294,  295,  290,  291,  298,  268,  313,  270,
  313,  386,  330,  386,  298,  386,  265,  392,  313,  268,
  337,  270,  265,  391,  387,  400,  291,  313,  265,  392,
  291,  380,  392,  382,  383,  384,  384,  400,  310,  311,
  256,  432,  336,  380,  493,  382,  383,  384,  313,  398,
  313,  314,  501,  452,  453,  386,  387,  506,  352,  310,
  311,  398,  380,  337,  382,  383,  384,  387,  385,  623,
  268,  400,  270,  464,  391,  466,  467,  392,  477,  380,
  398,  382,  383,  384,  394,  639,  335,  336,  337,  395,
  313,  482,  315,  336,  337,  649,  265,  398,  392,  292,
  549,  294,  295,  352,  332,  411,  400,  313,  662,  352,
  391,  429,  313,  314,  315,  400,    0,  290,  313,  292,
  315,  294,  295,  291,  292,  298,  294,  295,  338,  313,
  298,  315,  313,  473,  452,  453,  527,  386,  444,  313,
  313,  447,  486,  392,  488,  594,  313,  596,  597,  392,
  265,  400,  318,  319,  320,  321,  322,  400,  545,  477,
  522,  523,  511,  469,  268,  505,  615,  516,  517,  475,
  619,  520,  520,  268,  511,  481,  313,  314,  315,  516,
  517,  337,  631,  520,  633,  268,  470,  391,  391,  391,
   34,  391,  641,  511,  267,  391,  265,  515,  516,  517,
  518,  515,  520,  394,  518,  313,  386,  267,  526,  391,
  511,  337,  526,  392,  391,  516,  517,  290,  291,  520,
  391,  386,  386,  337,  530,  313,  313,  268,  386,  535,
  536,  392,  538,  386,  552,  392,  265,  392,  265,  302,
  313,  628,  629,  634,  392,  392,  400,  368,  266,  598,
  400,   95,  392,   97,  392,  561,  392,  267,  564,  543,
  566,  598,  546,  268,  399,  109,  110,  338,  313,  270,
  554,  265,  337,  557,  558,  337,  265,  400,  562,  391,
  598,  565,  588,  567,  602,  265,  392,  265,  602,  133,
  608,  372,  373,  374,  608,  391,  377,  598,  392,  380,
  381,  392,  265,  392,  385,  623,  387,  388,  389,  337,
  391,  595,  385,  386,  387,  338,  337,  337,  391,  392,
  392,  639,  265,  391,  270,  267,  267,  400,  267,  267,
  313,  649,  616,  268,  313,  268,  338,  643,  392,  392,
  392,  185,  626,  398,  662,  189,  190,  191,  192,  193,
  368,  369,  370,  337,  372,  373,  374,  201,  642,  377,
  268,  645,  380,  381,  268,  352,  265,  385,  313,  387,
  388,  389,  256,  391,  386,  352,  260,  261,  262,  663,
  352,  265,  266,  267,  268,  269,  268,  271,  272,  273,
  274,  275,  276,  277,  313,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,    0,  305,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  352,  305,  270,  333,
  334,  377,  291,  298,  380,  381,  400,  313,  291,  385,
  304,  387,  388,  389,  400,  391,  386,  338,  290,  291,
  354,  386,  265,  357,  392,  265,  392,  313,  313,  268,
  268,  268,  268,  367,  368,  386,  330,  331,  372,  268,
  352,  313,  314,  377,  505,  379,  380,  381,  276,  166,
  601,  385,  611,  387,  637,  418,  184,  391,  260,  261,
  262,  395,  396,  453,  398,  337,  400,  268,  452,  500,
  272,  273,  274,  275,  276,  277,  429,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  419,  570,
  291,  292,  517,  294,  295,  477,  265,  298,  274,  447,
   15,  521,  538,    0,  275,  540,   -1,   -1,   -1,  310,
  311,  535,  314,  315,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,
   -1,   -1,   -1,   -1,   -1,  429,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,  452,  453,
   -1,   -1,   -1,   -1,   -1,   -1,  368,   -1,   -1,   -1,
  372,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  473,
   -1,   -1,   -1,  477,   -1,   -1,   -1,   -1,   -1,  391,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,
   -1,   -1,   -1,  266,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  505,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,
   -1,   -1,  260,  261,  262,   -1,   -1,  265,  266,  267,
  268,  269,   -1,  271,  272,  273,  274,  275,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,   -1,   -1,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,   -1,   -1,  333,  334,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,   -1,  372,
  373,  374,   -1,   -1,  377,   -1,  354,  380,  381,  357,
   -1,   -1,  385,   -1,  387,  388,  389,   -1,  391,  367,
  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,
  266,  379,  380,  381,   -1,   -1,   -1,  385,   -1,  387,
   -1,   -1,   -1,  391,   -1,   -1,   -1,  395,  396,  256,
   -1,  399,  400,  260,  261,  262,   -1,   -1,  265,  266,
  267,   -1,  269,   -1,  271,  272,  273,  274,  275,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,   -1,
   -1,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,   -1,   -1,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,   -1,   -1,   -1,  333,  334,  364,  365,
  366,  367,  368,  369,  370,   -1,  372,  373,  374,   -1,
   -1,  377,   -1,   -1,  380,  381,   -1,  354,   -1,  385,
  357,  387,  388,  389,   -1,  391,   -1,   -1,   -1,   -1,
  367,  368,   -1,  265,  266,  372,  268,   -1,  270,   -1,
  377,   -1,  379,  380,  381,  260,  261,  262,  385,   -1,
  387,   -1,   -1,   -1,  391,   -1,   -1,   -1,  395,  396,
   -1,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,
  315,   -1,   -1,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  354,
   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  368,  386,   -1,   -1,  372,  266,   -1,
  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  391,  260,  261,  262,
   -1,   -1,  265,  266,  267,  400,  269,   -1,   -1,  272,
  273,  274,  275,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,   -1,   -1,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,   -1,   -1,  312,
  313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,
  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,  366,  367,
  368,  369,  370,   -1,  372,  373,  374,   -1,   -1,  377,
   -1,  354,  380,  381,  357,   -1,   -1,  385,   -1,  387,
  388,  389,   -1,  391,  367,  368,   -1,   -1,   -1,  372,
   -1,   -1,   -1,   -1,  377,   -1,  379,  380,  381,   -1,
   -1,   -1,  385,   -1,  387,   -1,   -1,   -1,  391,  260,
  261,  262,  395,  396,  265,  266,  267,   -1,  269,   -1,
   -1,  272,  273,  274,  275,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,   -1,
   -1,  312,  313,  314,  315,  316,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,   -1,
   -1,  372,   -1,   -1,   -1,   -1,  377,   -1,  379,  380,
  381,   -1,   -1,   -1,  385,   -1,  387,   -1,   -1,   -1,
  391,  260,  261,  262,  395,  396,  265,  266,  267,   -1,
  269,   -1,   -1,  272,  273,  274,  275,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,   -1,  312,  313,  314,  315,   -1,   -1,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,
   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,   -1,
  379,  380,  381,   -1,   -1,   -1,  385,   -1,  387,   -1,
   -1,   -1,  391,  260,  261,  262,  395,  396,  265,  266,
  267,   -1,  269,   -1,   -1,  272,  273,  274,  275,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,   -1,   -1,  293,   -1,   -1,   -1,
   -1,   -1,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,   -1,   -1,  312,  313,  314,  315,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,   -1,   -1,   -1,  333,  334,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,
  377,   -1,  379,  380,  381,   -1,   -1,   -1,  385,   -1,
  387,   -1,   -1,   -1,  391,   -1,   -1,   -1,  395,  396,
   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,   -1,   -1,
  377,   -1,   -1,  380,  381,   -1,   -1,   -1,  385,  386,
  387,  388,  389,   -1,  391,  392,  265,  266,   -1,  268,
   -1,  270,   -1,  400,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,   -1,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,   -1,  372,  373,
  374,   -1,   -1,  377,   -1,   -1,  380,  381,   -1,   -1,
   -1,  385,   -1,  387,  388,  389,   -1,  391,   -1,  266,
   -1,  268,   -1,  270,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,   -1,  372,  373,  374,   -1,   -1,  377,   -1,
   -1,  380,  381,   -1,   -1,   -1,  385,  386,  387,  388,
  389,   -1,  391,  392,  265,  266,   -1,  268,  335,  270,
  337,  400,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,   -1,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,   -1,   -1,
  377,   -1,   -1,  380,  381,   -1,   -1,   -1,  385,   -1,
  387,  388,  389,   -1,  391,   -1,   -1,   -1,   -1,  266,
   -1,   -1,   -1,  270,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
   -1,  372,  373,  374,   -1,   -1,  377,   -1,   -1,  380,
  381,   -1,   -1,   -1,  385,  386,  387,  388,  389,   -1,
  391,  392,  265,  266,   -1,  268,   -1,  270,   -1,  400,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,   -1,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,   -1,   -1,
  377,   -1,   -1,  380,  381,   -1,   -1,   -1,  385,   -1,
  387,  388,  389,   -1,  391,   -1,   -1,  266,   -1,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,   -1,  372,
  373,  374,   -1,   -1,  377,   -1,   -1,  380,  381,   -1,
   -1,   -1,  385,  386,  387,  388,  389,   -1,  391,  392,
  265,  266,   -1,  268,   -1,  270,   -1,  400,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,   -1,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,   -1,  372,  373,  374,   -1,   -1,  377,  266,
   -1,  380,  381,   -1,   -1,   -1,  385,   -1,  387,  388,
  389,   -1,  391,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,  351,  400,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  266,   -1,
  377,   -1,   -1,  380,  381,   -1,   -1,   -1,  385,   -1,
  387,  388,  389,   -1,  391,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,   -1,  372,  373,  374,  266,   -1,  377,
   -1,   -1,  380,  381,   -1,   -1,   -1,  385,   -1,  387,
  388,  389,   -1,  391,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,   -1,  372,  373,  374,  266,   -1,  377,   -1,
   -1,  380,  381,   -1,   -1,   -1,  385,   -1,  387,  388,
  389,   -1,  391,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,   -1,  372,  373,  374,  266,   -1,  377,   -1,   -1,
  380,  381,   -1,   -1,   -1,  385,   -1,  387,  388,  389,
   -1,  391,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
   -1,  372,  373,  374,  266,   -1,  377,   -1,   -1,  380,
  381,   -1,   -1,   -1,  385,   -1,  387,  388,  389,   -1,
  391,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,   -1,
  372,  373,  374,   -1,   -1,  377,   -1,   -1,  380,  381,
   -1,   -1,   -1,  385,   -1,  387,  388,  389,   -1,  391,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  265,   -1,   -1,
  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  260,  261,  262,   -1,  386,   -1,
   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,
  276,  277,  400,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,  315,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  265,   -1,   -1,  268,   -1,  270,   -1,  354,   -1,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  386,  368,   -1,   -1,   -1,  372,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  391,  392,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  265,   -1,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  265,
   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  265,   -1,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  386,   -1,   -1,   -1,  265,   -1,  392,  268,   -1,  270,
   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,   -1,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  386,
   -1,  265,   -1,   -1,  268,  392,  270,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  265,  386,   -1,  268,   -1,  270,
   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  265,   -1,   -1,  268,
   -1,  270,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  400,  265,   -1,   -1,
  268,   -1,  270,   -1,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  265,   -1,   -1,
  268,   -1,  270,   -1,   -1,   -1,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,   -1,   -1,  265,   -1,   -1,
  268,  400,  270,   -1,   -1,   -1,   -1,   -1,  386,   -1,
   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,   -1,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  265,  352,   -1,  268,   -1,  270,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  386,   -1,
   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,  386,   -1,
   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,   -1,
  352,   -1,  260,  261,  262,   -1,   -1,   -1,  266,  267,
   -1,  269,   -1,   -1,  272,  273,  274,  275,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,   -1,   -1,  386,   -1,   -1,   -1,   -1,   -1,
  392,  299,  300,   -1,   -1,   -1,   -1,   -1,  400,   -1,
   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,   -1,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,
   -1,  379,  380,  381,   -1,   -1,   -1,  385,   -1,  387,
  260,  261,  262,  391,   -1,   -1,  266,   -1,   -1,  269,
   -1,   -1,  272,  273,  274,  275,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
  300,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,
   -1,   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,
   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,   -1,  379,
  380,  381,   -1,   -1,   -1,  385,   -1,  387,  260,  261,
  262,  391,   -1,   -1,  266,  267,  268,  269,   -1,   -1,
   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,
   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,   -1,   -1,
   -1,  333,  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,
  372,   -1,   -1,   -1,   -1,  377,   -1,  379,  380,  381,
   -1,   -1,   -1,  385,   -1,  387,  260,  261,  262,  391,
   -1,   -1,  266,   -1,  268,  269,   -1,   -1,   -1,   -1,
   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,
  314,  315,   -1,   -1,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,
  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,  372,   -1,
   -1,   -1,   -1,  377,   -1,  379,  380,  381,   -1,   -1,
   -1,  385,   -1,  387,  260,  261,  262,  391,   -1,   -1,
  266,  267,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,
   -1,   -1,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,
   -1,  377,   -1,  379,  380,  381,   -1,   -1,   -1,  385,
   -1,  387,  260,  261,  262,  391,   -1,   -1,  266,   -1,
   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,   -1,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,
   -1,  379,  380,  381,   -1,   -1,   -1,  385,  386,  387,
  260,  261,  262,  391,   -1,   -1,  266,   -1,   -1,  269,
  270,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,
   -1,   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,
   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,   -1,  379,
  380,  381,   -1,   -1,   -1,  385,   -1,  387,  260,  261,
  262,  391,   -1,   -1,  266,  267,   -1,  269,   -1,   -1,
   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,
   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,   -1,   -1,
   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,
  372,   -1,   -1,   -1,   -1,  377,   -1,  379,  380,  381,
   -1,   -1,   -1,  385,   -1,  387,  260,  261,  262,  391,
   -1,   -1,  266,   -1,   -1,  269,   -1,   -1,   -1,   -1,
   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,
  314,  315,   -1,   -1,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,
  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,  372,   -1,
   -1,   -1,   -1,  377,   -1,  379,  380,  381,   -1,   -1,
   -1,  385,   -1,  387,  260,  261,  262,  391,   -1,   -1,
  266,  267,   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,
   -1,   -1,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,
   -1,  377,   -1,  379,  380,  381,   -1,   -1,   -1,  385,
   -1,  387,  260,  261,  262,  391,   -1,   -1,  266,   -1,
   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,   -1,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
  368,   -1,   -1,   -1,  372,  260,  261,  262,   -1,  377,
   -1,  379,  380,  381,   -1,   -1,   -1,  385,   -1,  387,
   -1,  276,  277,  391,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,  262,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  313,  314,
  315,   -1,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,
  314,  315,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  368,   -1,   -1,   -1,  372,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  391,   -1,   -1,   -1,
  354,   -1,   -1,  357,   -1,  266,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  368,   -1,   -1,   -1,  372,   -1,
   -1,   -1,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  391,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
  266,   -1,  377,   -1,   -1,  380,  381,   -1,   -1,   -1,
  385,   -1,  387,  388,  389,   -1,  391,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
   -1,  372,  373,  374,   -1,  266,  377,   -1,   -1,  380,
  381,   -1,   -1,   -1,  385,   -1,  387,  388,  389,  335,
  391,   -1,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,   -1,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,   -1,  372,  373,  374,  266,
   -1,  377,   -1,   -1,  380,  381,   -1,   -1,   -1,  385,
   -1,  387,  388,  389,   -1,  391,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,   -1,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
   -1,  372,  373,  374,   -1,   -1,  377,   -1,   -1,  380,
  381,   -1,   -1,   -1,  385,   -1,  387,  388,  389,   -1,
  391,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,   -1,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,   -1,   -1,
  377,   -1,   -1,  380,  381,   -1,   -1,   -1,  385,   -1,
  387,  388,  389,   -1,  391,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 400
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"VAR","EXPR","ARRAY","STRUCT",
"UNION","ENUM","COMP","HASH","SEMI","MOD","OC","CC","DOLLAR","DOTDOTDOT",
"ENDFILE","GLOBAL","AUTO","STATIC","CONST","POLY","INTEGER","NATURAL",
"RATIONAL","REAL","STRING","FOREIGN","FILET","MUTEX","SEMAPHORE","CONTINUATION",
"THREAD","VOID","BOOL","FUNCTION","FUNC","EXCEPTION","RAISE","TYPEDEF","IMPORT",
"NEW","ANONINIT","NAMESPACE","PUBLIC","PROTECTED","EXTEND","WHILE","DO","FOR",
"SWITCH","BREAK","CONTINUE","RETURNTOK","FORK","CASE","DEFAULT","TWIXT","NAME",
"TYPENAME","NAMESPACENAME","COMMAND","NAMECOMMAND","TEN_NUM","OCTAL0_NUM",
"OCTAL_NUM","BINARY_NUM","HEX_NUM","TEN_FLOAT","OCTAL0_FLOAT","OCTAL_FLOAT",
"BINARY_FLOAT","HEX_FLOAT","CHAR_CONST","STRING_CONST","POLY_CONST",
"THREAD_CONST","COMMENT_CONST","VOIDVAL","BOOLVAL","DARROW","POUND","COMMA",
"ASSIGN","ASSIGNPLUS","ASSIGNMINUS","ASSIGNTIMES","ASSIGNDIVIDE","ASSIGNDIV",
"ASSIGNMOD","ASSIGNPOW","ASSIGNSHIFTL","ASSIGNSHIFTR","ASSIGNLXOR","ASSIGNLAND",
"ASSIGNLOR","QUEST","COLON","OR","AND","LOR","LXOR","LAND","EQ","NE","LT","GT",
"LE","GE","SHIFTL","SHIFTR","PLUS","MINUS","TIMES","DIVIDE","DIV","POW",
"STARSTAR","POW2","POW3","UNIONCAST","UMINUS","BANG","FACT","LNOT","INC","DEC",
"STAR","AMPER","THREADID","OS","CS","DOT","ARROW","STAROS","CALL","OP","CP",
"POINTER","COLONCOLON","IF","TRY","NONL","ELSE","CATCH","NL",
};
char *yyrule[] = {
"$accept : lines",
"lines : lines pcommand",
"lines :",
"pcommand : command",
"pcommand : error reset eend",
"eend : NL",
"eend : SEMI",
"eend : ENDFILE",
"ignorenl :",
"attendnl :",
"reset :",
"not_command :",
"opt_nl : NL",
"opt_nl :",
"opt_semi : SEMI",
"opt_semi :",
"opt_comma : COMMA",
"opt_comma :",
"command : not_command expr reset NL",
"command : not_command expr POUND expr reset NL",
"command : not_command statement reset opt_nl",
"command : not_command COMMAND opt_exprs reset opt_semi NL",
"command : not_command NAMECOMMAND opt_rawnames reset opt_semi NL",
"command : NL",
"command : ENDFILE",
"opt_rawnames : rawnames",
"opt_rawnames :",
"rawnames : rawname COMMA rawnames",
"rawnames : rawname",
"rawname : rawnamespace rawatom",
"rawatom : NAME",
"rawatom : NAMESPACENAME",
"rawatom : TYPENAME",
"rawnamespace : rawnamespace rawatom COLONCOLON",
"rawnamespace :",
"fulltype : namespace TYPENAME",
"fulltype : TYPENAME",
"fullname : namespace namespacename",
"fullname : namespacename",
"fullnames : fullname",
"fullnames : fullname COMMA fullnames",
"namespace : namespace NAMESPACENAME COLONCOLON",
"namespace : NAMESPACENAME COLONCOLON",
"namespacename : NAME",
"namespacename : NAMESPACENAME",
"namespace_start :",
"namespace_end :",
"block : block_start statements block_end",
"block_start : OC namespace_start",
"block_end : namespace_end CC",
"statements : statement statements",
"statements :",
"if_statement : IF ignorenl namespace_start OP expr CP statement",
"if_statement : IF ignorenl namespace_start OP expr CP statement ELSE statement",
"statement : simple_statement",
"statement : block",
"simple_statement : if_statement namespace_end attendnl",
"simple_statement : WHILE ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"simple_statement : DO ignorenl namespace_start statement WHILE OP expr CP namespace_end attendnl",
"simple_statement : FOR ignorenl namespace_start OP for_exprs CP statement namespace_end attendnl",
"simple_statement : SWITCH ignorenl namespace_start OP expr CP case_block namespace_end attendnl",
"simple_statement : union_or_enum SWITCH ignorenl namespace_start OP expr CP union_case_block namespace_end attendnl",
"simple_statement : BREAK SEMI",
"simple_statement : CONTINUE SEMI",
"simple_statement : RETURNTOK opt_expr SEMI",
"simple_statement : expr SEMI",
"simple_statement : SEMI",
"simple_statement : func_decl doc_string opt_func_body namespace_end",
"simple_statement : opt_publish EXCEPTION ignorenl NAME namespace_start opt_argdecls namespace_end doc_string SEMI attendnl",
"simple_statement : RAISE fullname OP opt_exprs CP SEMI",
"simple_statement : opt_publish TYPEDEF ignorenl typenames SEMI attendnl",
"simple_statement : opt_publish TYPEDEF ignorenl type typenames SEMI attendnl",
"$$1 :",
"simple_statement : publish_extend NAMESPACE ignorenl namespacename $$1 OC statements CC attendnl",
"simple_statement : opt_publish IMPORT ignorenl fullnames SEMI attendnl",
"simple_statement : try_statement attendnl",
"simple_statement : TWIXT ignorenl namespace_start OP opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"for_exprs : opt_expr SEMI for_exprs",
"for_exprs : opt_expr",
"try_body_statement : simple_statement",
"try_body_statement : OC statements CC",
"try_statement : TRY ignorenl try_body_statement catches",
"catches : catches catch",
"catches :",
"catch : CATCH fullname namespace_start args doc_string block namespace_end",
"opt_func_body : func_body",
"opt_func_body : SEMI",
"$$2 :",
"func_body : $$2 block_or_expr",
"block_or_expr : block",
"block_or_expr : attendnl ASSIGN simpleexpr SEMI",
"union_or_enum : UNION",
"union_or_enum : ENUM",
"see_comment :",
"doc_string : see_comment opt_comment",
"opt_comment : COMMENT_CONST",
"opt_comment :",
"case_block : block_start cases block_end",
"cases : case cases",
"cases :",
"case : CASE expr COLON statements",
"case : DEFAULT COLON statements",
"union_case_block : block_start union_cases block_end",
"union_cases : union_case union_cases",
"union_cases :",
"union_case : CASE namespace_start NAME opt_name COLON statements namespace_end",
"union_case : DEFAULT COLON statements",
"opt_name : NAME",
"opt_name :",
"atoms : NAME COMMA atoms",
"atoms : NAME",
"typenames : typename COMMA typenames",
"typenames : typename",
"typename : TYPENAME",
"typename : NAME",
"initnames : name opt_init next_decl initnames",
"initnames : name opt_init",
"name : NAME",
"next_decl : COMMA",
"func_decl : func_name namespace_start opt_argdefines CP",
"func_name : decl NAME OP",
"func_name : decl FUNCTION NAME OP",
"func_name : FUNCTION ignorenl NAME OP",
"opt_init : ASSIGN simpleexpr",
"opt_init : ASSIGN init",
"opt_init :",
"decl : publish class type opt_nl",
"decl : class type opt_nl",
"decl : publish type opt_nl",
"decl : type opt_nl",
"decl : publish class opt_nl",
"decl : class opt_nl",
"decl : publish opt_nl",
"subscripts : opt_argdecls subscripts",
"subscripts : OS opt_stars CS subscripts",
"subscripts : OS dotdotdots CS subscripts",
"subscripts : OS dims CS subscripts",
"subscripts : OS type CS subscripts",
"subscripts :",
"type : subtype subscripts",
"type : TIMES type",
"type : STARSTAR type",
"type : AND type",
"type : LAND type",
"subtype : basetype",
"subtype : STRUCT OC struct_members CC",
"subtype : UNION OC union_members CC",
"subtype : ENUM OC atoms CC",
"subtype : OP type CP",
"subtype : fulltype",
"opt_type : type",
"opt_type :",
"basetype : POLY",
"basetype : INTEGER",
"basetype : RATIONAL",
"basetype : REAL",
"basetype : STRING",
"basetype : FILET",
"basetype : MUTEX",
"basetype : SEMAPHORE",
"basetype : CONTINUATION",
"basetype : THREAD",
"basetype : VOID",
"basetype : BOOL",
"basetype : FOREIGN",
"opt_stars : stars",
"opt_stars :",
"stars : stars COMMA TIMES",
"stars : TIMES",
"dotdotdots : dotdotdots COMMA DOTDOTDOT",
"dotdotdots : DOTDOTDOT",
"dims : simpleexpr COMMA dims",
"dims : simpleexpr",
"struct_members : opt_type atoms SEMI struct_members",
"struct_members :",
"union_members : opt_type atoms SEMI union_members",
"union_members :",
"class : GLOBAL",
"class : AUTO",
"class : STATIC",
"class : CONST",
"opt_publish : publish",
"opt_publish :",
"publish : PUBLIC",
"publish : PROTECTED",
"publish_extend : opt_publish",
"publish_extend : EXTEND",
"opt_argdecls : OP argdecls CP",
"opt_argdecls : OP CP",
"argdecls : argdecl COMMA argdecls",
"argdecls : argdecl opt_dotdotdot",
"argdecl : type NAME",
"argdecl : type",
"args : OP opt_argdefines CP",
"opt_argdefines : ignorenl argdefines",
"opt_argdefines : ignorenl",
"argdefines : argdefine COMMA argdefines",
"argdefines : argdefine opt_dotdotdot",
"argdefine : opt_type NAME",
"argdefine : type",
"opt_dotdotdot : DOTDOTDOT",
"opt_dotdotdot :",
"opt_expr : expr",
"opt_expr :",
"expr : comma_expr",
"expr : decl initnames",
"comma_expr : simpleexpr",
"comma_expr : comma_expr COMMA simpleexpr",
"opt_exprs : exprs",
"opt_exprs :",
"exprs : simpleexpr COMMA exprs",
"exprs : simpleexpr",
"opt_actuals : actuals",
"opt_actuals :",
"actuals : simpleexpr COMMA actuals",
"actuals : simpleexpr opt_dotdotdot",
"func_right : attendnl ASSIGN simpleexpr",
"$$3 :",
"func_right : $$3 block",
"simpleexpr : simpleexpr assignop simpleexpr",
"simpleexpr : opt_type FUNC namespace_start args doc_string func_right namespace_end",
"simpleexpr : MOD integer",
"simpleexpr : TIMES simpleexpr",
"simpleexpr : STARSTAR simpleexpr",
"simpleexpr : LAND simpleexpr",
"simpleexpr : AND simpleexpr",
"simpleexpr : MINUS simpleexpr",
"simpleexpr : LNOT simpleexpr",
"simpleexpr : BANG simpleexpr",
"simpleexpr : simpleexpr BANG",
"simpleexpr : INC simpleexpr",
"simpleexpr : simpleexpr INC",
"simpleexpr : DEC simpleexpr",
"simpleexpr : simpleexpr DEC",
"simpleexpr : FORK simpleexpr",
"simpleexpr : simpleexpr PLUS simpleexpr",
"simpleexpr : simpleexpr MINUS simpleexpr",
"simpleexpr : simpleexpr TIMES simpleexpr",
"simpleexpr : simpleexpr DIVIDE simpleexpr",
"simpleexpr : simpleexpr DIV simpleexpr",
"simpleexpr : simpleexpr MOD simpleexpr",
"simpleexpr : simpleexpr STARSTAR simpleexpr",
"simpleexpr : simpleexpr POW2",
"simpleexpr : simpleexpr POW3",
"simpleexpr : simpleexpr SHIFTL simpleexpr",
"simpleexpr : simpleexpr SHIFTR simpleexpr",
"simpleexpr : simpleexpr QUEST simpleexpr COLON simpleexpr",
"simpleexpr : simpleexpr LXOR simpleexpr",
"simpleexpr : simpleexpr LAND simpleexpr",
"simpleexpr : simpleexpr LOR simpleexpr",
"simpleexpr : simpleexpr AND simpleexpr",
"simpleexpr : simpleexpr OR simpleexpr",
"simpleexpr : simpleexpr EQ simpleexpr",
"simpleexpr : simpleexpr NE simpleexpr",
"simpleexpr : simpleexpr LT simpleexpr",
"simpleexpr : simpleexpr GT simpleexpr",
"simpleexpr : simpleexpr LE simpleexpr",
"simpleexpr : simpleexpr GE simpleexpr",
"simpleexpr : fullname",
"simpleexpr : TEN_NUM",
"simpleexpr : OCTAL_NUM",
"simpleexpr : OCTAL0_NUM",
"simpleexpr : BINARY_NUM",
"simpleexpr : HEX_NUM",
"simpleexpr : TEN_FLOAT",
"simpleexpr : OCTAL_FLOAT",
"simpleexpr : OCTAL0_FLOAT",
"simpleexpr : BINARY_FLOAT",
"simpleexpr : HEX_FLOAT",
"simpleexpr : CHAR_CONST",
"simpleexpr : STRING_CONST",
"simpleexpr : VOIDVAL",
"simpleexpr : BOOLVAL",
"simpleexpr : OS CS",
"simpleexpr : OP type CP namespace_start init namespace_end",
"simpleexpr : OP OS stars CS CP namespace_start arrayinit namespace_end",
"simpleexpr : OP OS dims CS CP namespace_start opt_arrayinit namespace_end",
"simpleexpr : OP OS type CS CP namespace_start opt_hashinit namespace_end",
"simpleexpr : type DOT NAME",
"simpleexpr : OP type DOT NAME CP simpleexpr",
"simpleexpr : DOLLAR opt_integer",
"simpleexpr : DOT",
"simpleexpr : OP expr CP",
"simpleexpr : OP block CP",
"simpleexpr : simpleexpr STAROS dims CS",
"simpleexpr : simpleexpr OS dims CS",
"simpleexpr : simpleexpr OP opt_actuals CP",
"simpleexpr : simpleexpr DOT NAME",
"simpleexpr : simpleexpr ARROW NAME",
"opt_integer : integer",
"opt_integer :",
"assignop : ASSIGNPLUS",
"assignop : ASSIGNMINUS",
"assignop : ASSIGNTIMES",
"assignop : ASSIGNDIVIDE",
"assignop : ASSIGNDIV",
"assignop : ASSIGNMOD",
"assignop : ASSIGNPOW",
"assignop : ASSIGNSHIFTL",
"assignop : ASSIGNSHIFTR",
"assignop : ASSIGNLXOR",
"assignop : ASSIGNLAND",
"assignop : ASSIGNLOR",
"assignop : ASSIGN",
"integer : TEN_NUM",
"integer : OCTAL_NUM",
"integer : OCTAL0_NUM",
"integer : BINARY_NUM",
"integer : HEX_NUM",
"opt_arrayinit : arrayinit",
"opt_arrayinit : OC CC",
"opt_arrayinit :",
"arrayinit : OC arrayelts opt_comma opt_dotdotdot CC",
"arrayinit : OC OS namespace_start compnames comparray CS comprehension namespace_end CC",
"comprehension : ASSIGN arrayelt",
"comprehension : block",
"compnames : compname COMMA compnames",
"compnames : compname",
"compname : NAME",
"comparray :",
"arrayelts : arrayelts COMMA arrayelt",
"arrayelts : arrayelt",
"arrayelt : simpleexpr",
"arrayelt : init",
"opt_hashinit : hashinit",
"opt_hashinit : OC CC",
"opt_hashinit :",
"hashinit : OC hashelts opt_comma CC",
"hashelts : hashelts COMMA hashelt",
"hashelts : hashelt",
"hashelt : simpleexpr DARROW hashvalue",
"hashelt : DARROW hashvalue",
"hashvalue : simpleexpr",
"hashvalue : init",
"structinit : OC structelts opt_comma CC",
"structelts : structelts COMMA structelt",
"structelts : structelt",
"structelt : NAME ASSIGN simpleexpr",
"structelt : NAME ASSIGN init",
"init : arrayinit",
"init : structinit",
"init : hashinit",
"init : OC CC",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1607 "gram.y"

static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp, CodePtr *cp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
    if (CurrentFrame)
	*cp = CurrentFrame->function->func.code;
    else
	*cp = 0;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    ArrayValueSet (&array->array, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	ArrayValueSet (&array->array, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk for() loop arguments and normalize the list
 */
static Expr *
ParseCanonFor (Expr *expr)
{
    if (!expr || !expr->tree.right) {
        ParseError ("Too few exprs in for()\n");
        return 0;
    }
    if (!expr->tree.right->tree.right) {
        /* 2-argument for() */
        expr = NewExprTree(FOR, 0, expr);
    }
    if (expr->tree.right->tree.right->tree.right) {
        ParseError ("Too many exprs in for()\n");
        return 0;
    }
    return expr;
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;
    
    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return False;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type, Void);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ParseError ("%s before %S", msg, yytext);
}
#line 2863 "gram.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 196 "gram.y"
{ yyerrok; }
break;
case 6:
#line 198 "gram.y"
{ yyerrok; }
break;
case 7:
#line 200 "gram.y"
{ yyerrok; }
break;
case 8:
#line 208 "gram.y"
{ ignorenl++; }
break;
case 9:
#line 211 "gram.y"
{ ignorenl--; }
break;
case 10:
#line 214 "gram.y"
{ 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
		    }
break;
case 11:
#line 231 "gram.y"
{ notCommand = 1; }
break;
case 18:
#line 246 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, yyvsp[-2].expr, 0));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 19:
#line 262 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, yyvsp[-4].expr, 0), yyvsp[-2].expr);
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 20:
#line 278 "gram.y"
{ 
			ENTER ();
			NamespacePtr    s;
			FramePtr	f;
			CodePtr		c;
			Value		t;
			
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileStat (yyvsp[-2].expr, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 21:
#line 291 "gram.y"
{
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 22:
#line 315 "gram.y"
{
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 26:
#line 344 "gram.y"
{ yyval.expr = 0; }
break;
case 27:
#line 347 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 28:
#line 349 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 29:
#line 352 "gram.y"
{ yyval.expr = BuildRawname (yyvsp[-1].expr, yyvsp[0].atom); }
break;
case 33:
#line 359 "gram.y"
{ yyval.expr = NewExprTree (COLONCOLON, yyvsp[-2].expr, NewExprAtom (yyvsp[-1].atom, 0, False)); }
break;
case 34:
#line 361 "gram.y"
{ yyval.expr = 0; }
break;
case 35:
#line 364 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 36:
#line 369 "gram.y"
{ 
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 37:
#line 375 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 38:
#line 380 "gram.y"
{
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 39:
#line 386 "gram.y"
{
			yyval.expr = yyvsp[0].expr;
		    }
break;
case 40:
#line 390 "gram.y"
{
			yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr);
		    }
break;
case 41:
#line 395 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (yyvsp[-2].expr, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 42:
#line 418 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 45:
#line 448 "gram.y"
{ CurrentNamespace = NewNamespace (CurrentNamespace); }
break;
case 46:
#line 451 "gram.y"
{ CurrentNamespace = CurrentNamespace->previous; }
break;
case 47:
#line 454 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 50:
#line 461 "gram.y"
{ yyval.expr = NewExprTree(OC, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 51:
#line 463 "gram.y"
{ yyval.expr = NewExprTree(OC, 0, 0); }
break;
case 52:
#line 466 "gram.y"
{ yyval.expr = NewExprTree(IF, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 53:
#line 468 "gram.y"
{ yyval.expr = NewExprTree(ELSE, yyvsp[-4].expr, NewExprTree(ELSE, yyvsp[-2].expr, yyvsp[0].expr)); }
break;
case 56:
#line 475 "gram.y"
{ yyval.expr = yyvsp[-2].expr; }
break;
case 57:
#line 477 "gram.y"
{ yyval.expr = NewExprTree(WHILE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 58:
#line 479 "gram.y"
{ yyval.expr = NewExprTree(DO, yyvsp[-6].expr, yyvsp[-3].expr); }
break;
case 59:
#line 481 "gram.y"
{ Expr *expr = ParseCanonFor(yyvsp[-4].expr);
		      if (!expr)
                          YYERROR;
		      yyval.expr = NewExprTree(FOR, expr, yyvsp[-2].expr); }
break;
case 60:
#line 486 "gram.y"
{ yyval.expr = NewExprTree (SWITCH, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 61:
#line 488 "gram.y"
{ yyval.expr = NewExprTree (UNION, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 62:
#line 490 "gram.y"
{ yyval.expr = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
break;
case 63:
#line 492 "gram.y"
{ yyval.expr = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
break;
case 64:
#line 494 "gram.y"
{ yyval.expr = NewExprTree (RETURNTOK, (Expr *) 0, yyvsp[-1].expr); }
break;
case 65:
#line 496 "gram.y"
{ yyval.expr = NewExprTree(EXPR, yyvsp[-1].expr, (Expr *) 0); }
break;
case 66:
#line 498 "gram.y"
{ yyval.expr = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
break;
case 67:
#line 500 "gram.y"
{ 
			DeclList    *decl = yyvsp[-3].funcDecl.decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = yyvsp[-3].funcDecl.type.class;
			Publish	    publish = yyvsp[-3].funcDecl.type.publish;
			TypePtr	    type = yyvsp[-3].funcDecl.type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if (yyvsp[-1].expr)
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       yyvsp[-1].expr,
								       yyvsp[-2].value),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			yyval.expr = NewExprDecl (FUNC, decl, class, type, publish);
		    }
break;
case 68:
#line 527 "gram.y"
{ 
			DeclListPtr decl;

			decl = NewDeclList (yyvsp[-6].atom, 0, 0);
			decl->symbol = ParseNewSymbol (yyvsp[-9].publish, 
						       class_exception, 
						       typePoly, yyvsp[-6].atom);
			decl->symbol->exception.doc = yyvsp[-2].value;
			yyval.expr = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, yyvsp[-4].argType),
					  yyvsp[-9].publish);
		    }
break;
case 69:
#line 542 "gram.y"
{ yyval.expr = NewExprTree (RAISE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 70:
#line 544 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-5].publish, class_typedef,
							   0, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, 0, yyvsp[-5].publish), 0);
		    }
break;
case 71:
#line 553 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-6].publish, class_typedef,
							   yyvsp[-3].type, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, yyvsp[-3].type, yyvsp[-6].publish), 0);
		    }
break;
case 72:
#line 562 "gram.y"
{
			SymbolPtr   symbol;
			Publish	    publish = yyvsp[-3].publish;
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			yyvsp[-2].namespace = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, yyvsp[0].atom, True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", yyvsp[0].atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", yyvsp[0].atom);
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].publish, class_namespace,
						     0, yyvsp[0].atom);
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != yyvsp[-2].namespace)
			    CurrentNamespace->publish = publish_public;
		    }
break;
case 73:
#line 603 "gram.y"
{
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != yyvsp[-7].namespace)
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = yyvsp[-7].namespace;
			yyval.expr = NewExprTree (NAMESPACE, NewExprAtom (yyvsp[-5].atom, 0, False), yyvsp[-2].expr);
		    }
break;
case 74:
#line 617 "gram.y"
{
			SymbolPtr	symbol;
			ExprPtr		p, e, n;

			p = yyvsp[-2].expr;
			for (p = yyvsp[-2].expr; p; p = n)
			{
			    if (p->base.tag == COMMA)
			    {
				e = p->tree.left;
				n = p->tree.right;
			    }
			    else
			    {
				e = p;
				n = 0;
			    }
			    if (e->base.tag == COLONCOLON)
				e = e->tree.right;
			    symbol = e->atom.symbol;
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", e->atom.atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", e->atom.atom);
				YYERROR;
			    }
			    NamespaceImport (CurrentNamespace, 
					     symbol->namespace.namespace, yyvsp[-5].publish);
			}
			yyval.expr = NewExprTree (IMPORT, yyvsp[-2].expr, NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   yyvsp[-5].publish));
		    }
break;
case 75:
#line 657 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 76:
#line 659 "gram.y"
{ yyval.expr = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, yyvsp[-6].expr, yyvsp[-4].expr),
					NewExprTree (TWIXT, yyvsp[-2].expr, 0));
		    }
break;
case 77:
#line 665 "gram.y"
{ yyval.expr = NewExprTree(SEMI, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 78:
#line 667 "gram.y"
{ yyval.expr = NewExprTree(SEMI, yyvsp[0].expr, 0); }
break;
case 80:
#line 672 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 81:
#line 675 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[0].expr, yyvsp[-1].expr); }
break;
case 82:
#line 679 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 83:
#line 681 "gram.y"
{ yyval.expr = 0; }
break;
case 84:
#line 684 "gram.y"
{ yyval.expr = NewExprCode (NewFuncCode (typePrim[rep_void],
						     yyvsp[-3].argType, yyvsp[-1].expr, yyvsp[-2].value),
					yyvsp[-5].expr); 
		    }
break;
case 86:
#line 691 "gram.y"
{ yyval.expr = 0; }
break;
case 87:
#line 693 "gram.y"
{ ++funcDepth; }
break;
case 88:
#line 693 "gram.y"
{ --funcDepth; yyval.expr = yyvsp[0].expr; }
break;
case 89:
#line 696 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 90:
#line 698 "gram.y"
{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yyvsp[-1].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 93:
#line 708 "gram.y"
{ seeComment = 1; }
break;
case 94:
#line 711 "gram.y"
{ seeComment = 0; yyval.value = yyvsp[0].value; }
break;
case 96:
#line 715 "gram.y"
{ yyval.value = Void; }
break;
case 97:
#line 718 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 98:
#line 721 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 99:
#line 723 "gram.y"
{ yyval.expr = 0; }
break;
case 100:
#line 726 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 101:
#line 728 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 102:
#line 731 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 103:
#line 734 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 104:
#line 736 "gram.y"
{ yyval.expr = 0; }
break;
case 105:
#line 739 "gram.y"
{ 
			SymbolPtr   sym = yyvsp[-3].symbol;
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			yyval.expr = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom (yyvsp[-4].atom, 0, False),
						       name),
					  yyvsp[-1].expr);
		    }
break;
case 106:
#line 754 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 107:
#line 757 "gram.y"
{
			yyval.symbol = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     yyvsp[0].atom);
		    }
break;
case 108:
#line 764 "gram.y"
{ yyval.symbol = 0; }
break;
case 109:
#line 770 "gram.y"
{ yyval.atomList = NewAtomList (yyvsp[0].atomList, yyvsp[-2].atom); }
break;
case 110:
#line 772 "gram.y"
{ yyval.atomList = NewAtomList (0, yyvsp[0].atom); }
break;
case 111:
#line 775 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[-2].atom, 0, yyvsp[0].declList); }
break;
case 112:
#line 777 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[0].atom, 0, 0); }
break;
case 115:
#line 790 "gram.y"
{ 
			if (yyvsp[-3].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-3].symbol->symbol.name, yyvsp[-2].expr, yyvsp[0].declList); 
			    yyval.declList->symbol = yyvsp[-3].symbol;
			}
			else
			    yyval.declList = yyvsp[0].declList;
		    }
break;
case 116:
#line 800 "gram.y"
{ 
			if (yyvsp[-1].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-1].symbol->symbol.name, yyvsp[0].expr, 0);
			    yyval.declList->symbol = yyvsp[-1].symbol;
			}
			else
			    yyvsp[-1].symbol = 0;
		    }
break;
case 117:
#line 811 "gram.y"
{	
			yyval.symbol = ParseNewSymbol (yyvsp[-1].fulltype.publish,
					     yyvsp[-1].fulltype.class,
					     yyvsp[-1].fulltype.type,
					     yyvsp[0].atom);
		    }
break;
case 118:
#line 823 "gram.y"
{ yyval.fulltype = yyvsp[-3].fulltype; }
break;
case 119:
#line 829 "gram.y"
{
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc (yyvsp[-3].funcDecl.type.type, yyvsp[-1].argType);
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, yyvsp[-3].funcDecl.decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    yyvsp[-3].funcDecl.decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].funcDecl.type.publish,
						     yyvsp[-3].funcDecl.type.class, 
						     type,
						     yyvsp[-3].funcDecl.decl->name);
			}
			CurrentNamespace = save;
			yyval.funcDecl = yyvsp[-3].funcDecl;
			yyval.funcDecl.decl->symbol = symbol;
			yyval.funcDecl.type.type = type;
		    }
break;
case 120:
#line 862 "gram.y"
{ yyval.funcDecl.type = yyvsp[-2].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 121:
#line 864 "gram.y"
{ yyval.funcDecl.type = yyvsp[-3].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 122:
#line 866 "gram.y"
{ 
			yyval.funcDecl.type.publish = publish_private;
			yyval.funcDecl.type.class = class_undef;
			yyval.funcDecl.type.type = typePoly;
			yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); 
		    }
break;
case 123:
#line 874 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 124:
#line 876 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 125:
#line 878 "gram.y"
{ yyval.expr = 0; }
break;
case 126:
#line 884 "gram.y"
{ yyval.fulltype.publish = yyvsp[-3].publish; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 127:
#line 886 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 128:
#line 888 "gram.y"
{ yyval.fulltype.publish = yyvsp[-2].publish; yyval.fulltype.class = class_undef; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 129:
#line 890 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = class_undef; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 130:
#line 892 "gram.y"
{ yyval.fulltype.publish = yyvsp[-2].publish; yyval.fulltype.class = yyvsp[-1].class; yyval.fulltype.type = typePoly; }
break;
case 131:
#line 894 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yyvsp[-1].class; yyval.fulltype.type = typePoly; }
break;
case 132:
#line 896 "gram.y"
{ yyval.fulltype.publish = yyvsp[-1].publish; yyval.fulltype.class = class_undef; yyval.fulltype.type = typePoly; }
break;
case 133:
#line 902 "gram.y"
{ yyval.type = NewTypeFunc (yyvsp[0].type, yyvsp[-1].argType); }
break;
case 134:
#line 904 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, False); }
break;
case 135:
#line 906 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, True); }
break;
case 136:
#line 908 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, False); }
break;
case 137:
#line 910 "gram.y"
{ yyval.type = NewTypeHash (yyvsp[0].type, yyvsp[-2].type); }
break;
case 138:
#line 912 "gram.y"
{ yyval.type = 0; }
break;
case 139:
#line 915 "gram.y"
{
			Type	*top = yyvsp[0].type;
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = yyvsp[-1].type;
			yyval.type = top;
		    }
break;
case 140:
#line 943 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, True); }
break;
case 141:
#line 945 "gram.y"
{ yyval.type = NewTypeRef (NewTypeRef (yyvsp[0].type, True), True); }
break;
case 142:
#line 947 "gram.y"
{ yyval.type = NewTypeRef (NewTypeRef (yyvsp[0].type, False), False); }
break;
case 143:
#line 949 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, False); }
break;
case 145:
#line 953 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeStruct (st);
		    }
break;
case 146:
#line 979 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeUnion (st, False);
		    }
break;
case 147:
#line 1005 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			yyval.type = NewTypeUnion (st, True);
		    }
break;
case 148:
#line 1026 "gram.y"
{ yyval.type = yyvsp[-1].type; }
break;
case 149:
#line 1028 "gram.y"
{ yyval.type = NewTypeName (yyvsp[0].expr, 0); }
break;
case 151:
#line 1032 "gram.y"
{ yyval.type = typePoly; }
break;
case 166:
#line 1050 "gram.y"
{ yyval.expr = 0; }
break;
case 167:
#line 1053 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[-2].expr); }
break;
case 168:
#line 1055 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 169:
#line 1058 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[-2].expr); }
break;
case 170:
#line 1060 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 171:
#line 1063 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 172:
#line 1065 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 173:
#line 1071 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 174:
#line 1073 "gram.y"
{ yyval.memList = 0; }
break;
case 175:
#line 1076 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 176:
#line 1078 "gram.y"
{ yyval.memList = 0; }
break;
case 182:
#line 1091 "gram.y"
{ yyval.publish = publish_private; }
break;
case 187:
#line 1105 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 188:
#line 1107 "gram.y"
{ yyval.argType = 0; }
break;
case 189:
#line 1110 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 190:
#line 1112 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 191:
#line 1115 "gram.y"
{ 
			ParseCanonType (yyvsp[-1].type, False);
			yyval.argDecl.type = yyvsp[-1].type; 
			yyval.argDecl.name = yyvsp[0].atom; 
		    }
break;
case 192:
#line 1121 "gram.y"
{ 
			ParseCanonType (yyvsp[0].type, False);
			yyval.argDecl.type = yyvsp[0].type;
			yyval.argDecl.name = 0; 
		    }
break;
case 193:
#line 1132 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 194:
#line 1135 "gram.y"
{
			ArgType	*args;
			Type	*type;

			for (args = yyvsp[0].argType; args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0),
						     False);
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			yyval.argType = yyvsp[0].argType;
		    }
break;
case 195:
#line 1160 "gram.y"
{ yyval.argType = 0; }
break;
case 196:
#line 1163 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 197:
#line 1165 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 198:
#line 1168 "gram.y"
{ yyval.argDecl.type = yyvsp[-1].type; yyval.argDecl.name = yyvsp[0].atom; }
break;
case 199:
#line 1170 "gram.y"
{ yyval.argDecl.type = yyvsp[0].type; yyval.argDecl.name = 0; }
break;
case 200:
#line 1173 "gram.y"
{ yyval.bool = True; }
break;
case 201:
#line 1175 "gram.y"
{ yyval.bool = False; }
break;
case 203:
#line 1183 "gram.y"
{ yyval.expr = 0; }
break;
case 205:
#line 1187 "gram.y"
{ 
			DeclList    *decl;

			for (decl = yyvsp[0].declList; decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = yyvsp[-1].fulltype.type;
			    }
			}

			yyval.expr = NewExprDecl (VAR, yyvsp[0].declList, yyvsp[-1].fulltype.class, yyvsp[-1].fulltype.type, yyvsp[-1].fulltype.publish); 
		    }
break;
case 207:
#line 1204 "gram.y"
{ yyval.expr = NewExprTree(COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 209:
#line 1211 "gram.y"
{ yyval.expr = 0; }
break;
case 210:
#line 1214 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 211:
#line 1216 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 213:
#line 1220 "gram.y"
{ yyval.expr = 0; }
break;
case 214:
#line 1223 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 215:
#line 1225 "gram.y"
{	
			ExprPtr	arg = yyvsp[0].bool ? NewExprTree (DOTDOTDOT, yyvsp[-1].expr, 0) : yyvsp[-1].expr;
			yyval.expr = NewExprTree (COMMA, arg, 0); 
		    }
break;
case 216:
#line 1231 "gram.y"
{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yyvsp[0].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 217:
#line 1236 "gram.y"
{ ++funcDepth; }
break;
case 218:
#line 1236 "gram.y"
{ --funcDepth; yyval.expr = yyvsp[0].expr; }
break;
case 219:
#line 1242 "gram.y"
{ 
			if (yyvsp[-1].ints == ASSIGNPOW)
			    yyval.expr = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, yyvsp[-2].expr, yyvsp[0].expr));
			else
			{
			    ExprPtr left = yyvsp[-2].expr;
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if (yyvsp[-1].ints == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				yyvsp[-2].expr->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  yyvsp[-2].expr->atom.atom);
			    }
			    yyval.expr = NewExprTree(yyvsp[-1].ints, yyvsp[-2].expr, yyvsp[0].expr); 
			}
		    }
break;
case 220:
#line 1268 "gram.y"
{
			ParseCanonType (yyvsp[-6].type, False);
			yyval.expr = NewExprCode (NewFuncCode (yyvsp[-6].type, yyvsp[-3].argType, yyvsp[-1].expr, yyvsp[-2].value), 0); 
		    }
break;
case 221:
#line 1273 "gram.y"
{   Value	t;
			t = do_Thread_id_to_thread (yyvsp[0].value);
			if (t == Void)
			{
			    ParseError ("No thread %v", yyvsp[0].value);
			    YYERROR;
			}
			else
			    yyval.expr = NewExprConst(THREAD_CONST, t); 
		    }
break;
case 222:
#line 1284 "gram.y"
{ yyval.expr = NewExprTree(STAR, yyvsp[0].expr, (Expr *) 0); }
break;
case 223:
#line 1286 "gram.y"
{ yyval.expr = NewExprTree(STAR, NewExprTree (STAR, yyvsp[0].expr, 0), 0); }
break;
case 224:
#line 1288 "gram.y"
{ yyval.expr = NewExprTree(AMPER, yyvsp[0].expr, (Expr *) 0); }
break;
case 225:
#line 1290 "gram.y"
{ yyval.expr = NewExprTree(AMPER, 
				       NewExprTree (AMPER, yyvsp[0].expr, (Expr *) 0), 
				       (Expr *) 0); }
break;
case 226:
#line 1294 "gram.y"
{ yyval.expr = NewExprTree(UMINUS, yyvsp[0].expr, (Expr *) 0); }
break;
case 227:
#line 1296 "gram.y"
{ yyval.expr = NewExprTree(LNOT, yyvsp[0].expr, (Expr *) 0); }
break;
case 228:
#line 1298 "gram.y"
{ yyval.expr = NewExprTree(BANG, yyvsp[0].expr, (Expr *) 0); }
break;
case 229:
#line 1300 "gram.y"
{ yyval.expr = NewExprTree(FACT, yyvsp[-1].expr, (Expr *) 0); }
break;
case 230:
#line 1302 "gram.y"
{ yyval.expr = NewExprTree(INC, yyvsp[0].expr, (Expr *) 0); }
break;
case 231:
#line 1304 "gram.y"
{ yyval.expr = NewExprTree(INC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 232:
#line 1306 "gram.y"
{ yyval.expr = NewExprTree(DEC, yyvsp[0].expr, (Expr *) 0); }
break;
case 233:
#line 1308 "gram.y"
{ yyval.expr = NewExprTree(DEC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 234:
#line 1310 "gram.y"
{ yyval.expr = NewExprTree (FORK, (Expr *) 0, yyvsp[0].expr); }
break;
case 235:
#line 1312 "gram.y"
{ yyval.expr = NewExprTree(PLUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 236:
#line 1314 "gram.y"
{ yyval.expr = NewExprTree(MINUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 237:
#line 1316 "gram.y"
{ yyval.expr = NewExprTree(TIMES, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 238:
#line 1318 "gram.y"
{ yyval.expr = NewExprTree(DIVIDE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 239:
#line 1320 "gram.y"
{ yyval.expr = NewExprTree(DIV, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 240:
#line 1322 "gram.y"
{ yyval.expr = NewExprTree(MOD, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 241:
#line 1324 "gram.y"
{ 
			yyval.expr = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, yyvsp[-2].expr, yyvsp[0].expr)); 
		    }
break;
case 242:
#line 1330 "gram.y"
{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yyvsp[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(2))));
		    }
break;
case 243:
#line 1338 "gram.y"
{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yyvsp[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(3))));
		    }
break;
case 244:
#line 1346 "gram.y"
{ yyval.expr = NewExprTree(SHIFTL, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 245:
#line 1348 "gram.y"
{ yyval.expr = NewExprTree(SHIFTR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 246:
#line 1350 "gram.y"
{ yyval.expr = NewExprTree(QUEST, yyvsp[-4].expr, NewExprTree(COLON, yyvsp[-2].expr, yyvsp[0].expr)); }
break;
case 247:
#line 1352 "gram.y"
{ yyval.expr = NewExprTree(LXOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 248:
#line 1354 "gram.y"
{ yyval.expr = NewExprTree(LAND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 249:
#line 1356 "gram.y"
{ yyval.expr = NewExprTree(LOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 250:
#line 1358 "gram.y"
{ yyval.expr = NewExprTree(AND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 251:
#line 1360 "gram.y"
{ yyval.expr = NewExprTree(OR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 252:
#line 1362 "gram.y"
{ yyval.expr = NewExprTree(EQ, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 253:
#line 1364 "gram.y"
{ yyval.expr = NewExprTree(NE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 254:
#line 1366 "gram.y"
{ yyval.expr = NewExprTree(LT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 255:
#line 1368 "gram.y"
{ yyval.expr = NewExprTree(GT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 256:
#line 1370 "gram.y"
{ yyval.expr = NewExprTree(LE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 257:
#line 1372 "gram.y"
{ yyval.expr = NewExprTree(GE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 259:
#line 1375 "gram.y"
{ yyval.expr = NewExprConst(TEN_NUM, yyvsp[0].value); }
break;
case 260:
#line 1377 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_NUM, yyvsp[0].value); }
break;
case 261:
#line 1379 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_NUM, yyvsp[0].value); }
break;
case 262:
#line 1381 "gram.y"
{ yyval.expr = NewExprConst(BINARY_NUM, yyvsp[0].value); }
break;
case 263:
#line 1383 "gram.y"
{ yyval.expr = NewExprConst(HEX_NUM, yyvsp[0].value); }
break;
case 264:
#line 1385 "gram.y"
{ yyval.expr = NewExprConst(TEN_FLOAT, yyvsp[0].value); }
break;
case 265:
#line 1387 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_FLOAT, yyvsp[0].value); }
break;
case 266:
#line 1389 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_FLOAT, yyvsp[0].value); }
break;
case 267:
#line 1391 "gram.y"
{ yyval.expr = NewExprConst(BINARY_FLOAT, yyvsp[0].value); }
break;
case 268:
#line 1393 "gram.y"
{ yyval.expr = NewExprConst(HEX_FLOAT, yyvsp[0].value); }
break;
case 269:
#line 1395 "gram.y"
{ yyval.expr = NewExprConst(CHAR_CONST, yyvsp[0].value); }
break;
case 270:
#line 1397 "gram.y"
{ yyval.expr = NewExprConst(STRING_CONST, yyvsp[0].value); }
break;
case 271:
#line 1399 "gram.y"
{ yyval.expr = NewExprConst(VOIDVAL, yyvsp[0].value); }
break;
case 272:
#line 1401 "gram.y"
{ yyval.expr = NewExprConst(BOOLVAL, yyvsp[0].value); }
break;
case 273:
#line 1403 "gram.y"
{ 
			yyval.expr = BuildFullname (0, AtomId ("[]"));
		    }
break;
case 274:
#line 1407 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = yyvsp[-4].type;
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 275:
#line 1415 "gram.y"
{ 
			yyvsp[-1].expr->base.type = NewTypeArray (typePoly, yyvsp[-5].expr, True); 
			ParseCanonType (yyvsp[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			yyval.expr->base.type = yyvsp[-1].expr->base.type;
		    }
break;
case 276:
#line 1422 "gram.y"
{ 
			TypePtr	t = NewTypeArray (typePoly, yyvsp[-5].expr, False);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 277:
#line 1431 "gram.y"
{
			TypePtr t = NewTypeHash (typePoly, yyvsp[-5].type);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 278:
#line 1440 "gram.y"
{
			ParseCanonType (yyvsp[-2].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[0].atom, 0, False), 0); 
			yyval.expr->base.type = yyvsp[-2].type;
		    }
break;
case 279:
#line 1446 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); 
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 280:
#line 1452 "gram.y"
{ yyval.expr = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, yyvsp[0].value)); }
break;
case 281:
#line 1454 "gram.y"
{ yyval.expr = NewExprTree (DOLLAR, 0, 0); }
break;
case 282:
#line 1456 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 283:
#line 1458 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 284:
#line 1460 "gram.y"
{ yyval.expr = NewExprTree (OS, NewExprTree (STAR, yyvsp[-3].expr, (Expr *) 0), yyvsp[-1].expr); }
break;
case 285:
#line 1462 "gram.y"
{ yyval.expr = NewExprTree(OS, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 286:
#line 1464 "gram.y"
{ yyval.expr = NewExprTree (OP, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 287:
#line 1466 "gram.y"
{ yyval.expr = NewExprTree(DOT, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 288:
#line 1468 "gram.y"
{ yyval.expr = NewExprTree(ARROW, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 290:
#line 1472 "gram.y"
{ yyval.value = Zero; }
break;
case 310:
#line 1498 "gram.y"
{ yyval.expr = 0; }
break;
case 311:
#line 1500 "gram.y"
{ yyval.expr = 0; }
break;
case 312:
#line 1503 "gram.y"
{ 
			ExprPtr	elts = yyvsp[-3].expr ? ExprRehang (yyvsp[-3].expr, 0) : 0;
			if (yyvsp[-1].bool)
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTDOTDOT, 0, 0),
							 0);
			}
			yyval.expr = NewExprTree (ARRAY, elts, 0); 
		    }
break;
case 313:
#line 1517 "gram.y"
{
			yyval.expr = NewExprTree (COMP, NewExprTree (COMP, yyvsp[-5].expr, yyvsp[-4].expr), yyvsp[-2].expr);
		    }
break;
case 314:
#line 1522 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 316:
#line 1526 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 318:
#line 1530 "gram.y"
{ 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], yyvsp[0].atom);
			yyval.expr = NewExprAtom (yyvsp[0].atom, s, False); 
		    }
break;
case 319:
#line 1538 "gram.y"
{
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			yyval.expr = NewExprAtom (a, s, False);
		    }
break;
case 320:
#line 1547 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 321:
#line 1549 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 325:
#line 1560 "gram.y"
{ yyval.expr = 0; }
break;
case 326:
#line 1562 "gram.y"
{ yyval.expr = 0; }
break;
case 327:
#line 1565 "gram.y"
{
			ExprPtr elts = yyvsp[-2].expr ? ExprRehang (yyvsp[-2].expr, 0) : 0;
			yyval.expr = NewExprTree (HASH, elts, 0);
		    }
break;
case 328:
#line 1571 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 329:
#line 1573 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 330:
#line 1576 "gram.y"
{ yyval.expr = NewExprTree (DARROW, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 331:
#line 1578 "gram.y"
{ yyval.expr = NewExprTree (DARROW, 0, yyvsp[0].expr); }
break;
case 334:
#line 1587 "gram.y"
{ yyval.expr = NewExprTree (STRUCT, ExprRehang (yyvsp[-2].expr, 0), 0); }
break;
case 335:
#line 1590 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 336:
#line 1592 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 337:
#line 1595 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 338:
#line 1597 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 342:
#line 1604 "gram.y"
{ yyval.expr = NewExprTree (ANONINIT, 0, 0); }
break;
#line 4648 "gram.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
